/* Public Variable */
var oTextRange;
var oElement;

/* setCurrentPosition: record the current insertion point
 * [tarObj] the current object
 */
function setCurrentPosition(tarObj)
{
	oTextRange = document.selection.createRange();
	oElement = tarObj;
}
/* setUIDisplay: set the UI range display or not
 * [srcState] true/false
 * [tarObj] the target object
 */
function setUIDisplay(srcState,tarObj)
{
	if (tarObj == null) return;
	tarObj.style.display = (srcState)?"block":"none";
}
/* setUIMoreDisplay: set the More range display or not and change the images
 * [tarObj] the target object
 */
function setUIMoreDisplay(tarObj)
{
	if (tarObj == null) return;
	var bFlag = (tarObj.src.search(/expand_right/i) > 0)?true:false;
	setUIDisplay(bFlag,document.all(tarObj.id + "_items"));
	if (bFlag){
		tarObj.src = tarObj.src.replace(/right/i,"left");
	} else {
		tarObj.src = tarObj.src.replace(/left/i,"right");
	}
}
/* setUITagDisplay: set the Tag range display or not and change the images
 * [index] the tag index => active
 * [count] the total number tag
 * [name] the tag name(description)
 */
function setUITagDisplay(index,count,name)
{
	if (index < 1 && index > count) return;
	if (count < 1) return;
	if (name == "") return;
	
	var sId = "";
	for (var i=1; i<=count; i++)
	{
		sId = "Tag" + i;
		if (i==index) {
			document.getElementById(sId).background = document.getElementById(sId).background.replace(/inactive/i,"active");
			document.getElementById(sId).innerHTML = name;
			document.getElementById(sId + "_imgS").src = document.getElementById(sId + "_imgS").src.replace(/inactive/i,"active");
			document.getElementById(sId + "_imgE").src = document.getElementById(sId + "_imgE").src.replace(/inactive/i,"active");
			document.getElementById(sId).className = "tabactive";
			setUIDisplay(true,document.getElementById(sId + "_items"));
		} else if (document.getElementById(sId).className == "tabactive") {
			document.getElementById(sId).background = document.getElementById(sId).background.replace(/active/i,"inactive");
			document.getElementById(sId).innerHTML = "<a class=\"subnavselect\" href=\"javascript:setUITagDisplay(" + i + "," + count + ",'" + document.getElementById(sId).innerText + "');\">" + document.getElementById(sId).innerText + "</a>";
			document.getElementById(sId + "_imgS").src = document.getElementById(sId + "_imgS").src.replace(/active/i,"inactive");
			document.getElementById(sId + "_imgE").src = document.getElementById(sId + "_imgE").src.replace(/active/i,"inactive");
			document.getElementById(sId).className = "tabinactive";
			setUIDisplay(false,document.getElementById(sId + "_items"));
		}
	}
}

function setUIFunctionLink(srcState, tarID)
{	
	if (document.all(tarID)) {
		if (document.all(tarID).length == null) {
			document.all(tarID).disabled = !srcState;
			document.all(tarID).style.cursor = (srcState)? "hand":"default";
			document.all(tarID).style.textDecoration = (srcState)? "underline":"none";
		} else {
			for (i=0;i<document.all(tarID).length;i++) {
			document.all(tarID)[i].disabled = !srcState;
			document.all(tarID)[i].style.cursor = (srcState)? "hand":"default";
			document.all(tarID)[i].style.textDecoration = (srcState)? "underline":"none";
			}
		}
	}
	if (document.all(tarID + "_img")) { 
		if (document.all(tarID + "_img").length == null) {
			if (!(document.all(tarID + "_img").src.search(/_gray.gif/i) > 0) != srcState) {
				if (srcState) {
				document.all(tarID + "_img").src = document.all(tarID + "_img").src.replace(/_gray.gif/i,".gif");
				} else {
				document.all(tarID + "_img").src = document.all(tarID + "_img").src.replace(/.gif/i,"_gray.gif");
				}
			}
		} else {
			if (!(document.all(tarID + "_img")[0].src.search(/_gray.gif/i) > 0) != srcState) {
				for (i=0;i<document.all(tarID + "_img").length;i++) {
				if (srcState) {
				document.all(tarID + "_img")[i].src = document.all(tarID + "_img")[i].src.replace(/_gray.gif/i,".gif");
				} else {
				document.all(tarID + "_img")[i].src = document.all(tarID + "_img")[i].src.replace(/.gif/i,"_gray.gif");
				}
				}
			}
		}
	}
}
function setUIChecked(srcState, tarObj)
{
	if (tarObj) {
		if (tarObj.length == null) {
			tarObj.checked = srcState;
		} else {
			for (i=0;i<tarObj.length;i++) {
				tarObj[i].checked = srcState;
			}
		}
	}
}
/* setMoveItem: move item from source to target object
 * srcObj: source object (text,select)
 * tarObj: target object (text,textarea,select)
 * bRemoveItem: remove the current item
 */
function setUIMoveItem(srcObj, tarObj, bRemoveItem)
{
	if (srcObj == null) return;
	if (tarObj == null) return;
	
	var nIndex = -1;
	if (srcObj.type.search(/text/i)>-1) {
		// source object is text
		nIndex = setUIAddItem(srcObj.value, tarObj);
		if (bRemoveItem) { srcObj.value = ""; }
	} else if (srcObj.type.search(/select/i)>-1) {
		// source object is select (list)
		if (srcObj.length == 0) { return; }
		for (var i=srcObj.length-1;i>-1;i--) {
			if (srcObj.options[i].selected) {nIndex = setUIAddItem(srcObj.options[i].text, tarObj);}
		}
		if (bRemoveItem) setUIDelfromList(srcObj);
	}
	return nIndex;
}
/* setUIAddItem: add item into target object
 * srcString: source string
 * tarObj: target object (text,textarea,select)
 */
function setUIAddItem(srcString, tarObj)
{
	if (srcString == "") return;
	if (tarObj == null) return;
	
	var nIndex = -1;
	if (tarObj.type.search(/select/i)>-1) {
		// target object is select (list)
		var oOption = document.createElement("OPTION");
		for (var i=0;i<tarObj.length;i++) {
			if (tarObj.options(i).value.toString(10) <= srcString.toString(10)) {}
			else {break;}
		}
		oOption.text = srcString;
		oOption.value = srcString;
		tarObj.options.add(oOption,i);
		nIndex = i;
	} else if (tarObj.type.search(/text/i)>-1) {
		// target object is text or textarea
		if (oElement == tarObj) {
			oTextRange.text = srcString;
		} else {
			tarObj.value += srcString;
		}
	}
	return nIndex;
}
/* setUIDelfromList: remove the selected item from list box
 * tarObj: target object (select)
 */
function setUIDelfromList(tarObj)
{
	if (tarObj == null) return;
	for (i=tarObj.length-1;i>-1;i--) {
		if (tarObj.options(i).selected) {
			tarObj.remove(i);
		}
	}
}
function getSelectedOptionValue(tarObj) {
	var strValue = "";
	if (tarObj == null) return strValue;
	if (tarObj.length == null) {
		if (tarObj.checked) {strValue = tarObj.value;}
	} else {
		for (i=0;i<tarObj.length;i++) {
		if (tarObj[i].checked) {strValue = strValue + "," + tarObj[i].value;}
		}
		if (strValue.length>0) {strValue = strValue.slice(1,strValue.length);}
	}
	return strValue;
}
/* setDateTimeValue: insert items
 * tarObj: combobox
 * srcString: item list
 */
function setDateTimeValue(tarObj,srcString) {
	if (tarObj == null) {return;}
	if (srcString == "") { return;}
	
	var oString = srcString.split(",");
	var oOption;
	for (var i=0; i<oString.length; i++) {
		oOption = document.createElement("OPTION");
		oOption.text = oString[i];
		oOption.value = oString[i];
		tarObj.options.add(oOption);
	}
}
/* setOptionValue: insert items
 * tarObj: combobox
 * srcString: item list
 * bIndex: value is index(true) or text(false)
 */
function setOptionValue(tarObj,srcString,bIndex) {
	if (tarObj == null) {return;}
	if (srcString == "") { return;}
	if (bIndex == null) { bIndex=true; }
	
	var oString = srcString.split(",");
	var oOption;
	for (var i=0; i<oString.length; i++) {
		oOption = document.createElement("OPTION");
		oOption.text = oString[i];
		if (bIndex) oOption.value = i;
		else oOption.value = oString[i];
		tarObj.options.add(oOption);
	}
}
function setOptionValueEx(tarObj,strDisplay,strValue) {
	if (tarObj == null) {return;}
	if (strDisplay == "") { return;}
	if (strValue == "") { return;}
	
	var oDisplay = strDisplay.split(",");
	var oValue = strValue.split(",");
	if(oDisplay.length > oValue.length) { return; }
	
	var oOption;
	for (var i=0; i<oDisplay.length; i++) {
		oOption = document.createElement("OPTION");
		oOption.text = oDisplay[i];
		oOption.value = oValue[i];
		tarObj.options.add(oOption);
	}
}
/* setDeviceOptionValueWithAttrib: insert option items in the Cisco Devices listbox
 * tarObj: listbox
 * srcString: item list
 * srcAttrib: attrib list for item list
 * bIndex: value is index(true) or text(false)
 */
function setDeviceOptionValueWithAttrib(tarObj,srcString,srcAttrib,bIndex) {
	if (tarObj == null) {return;}
	if (srcString == "") { return;}
	if (srcAttrib == "") { return;}
	if (bIndex == null) { bIndex=true; }

	var oString = srcString.split(",");
	var oAttrib = srcAttrib.split(",");

	if ( oString.length != oAttrib.length )
	{
		alert(STR_ERR_INIT_PAGE_FAIL);
		window.close();
	}

	var oOption;
	for (var i=0; i<oString.length; i++) {
		oOption = document.createElement("OPTION");
		oOption.text = oString[i];
		oOption.setAttribute("DeviceType", oAttrib[i]);
		if (bIndex) oOption.value = i;
		else oOption.value = oString[i];
		tarObj.options.add(oOption);
	}
}
/* setDateTimeFormat: set the datetime format  [mm/dd/yyyy hh:mm]
 * tarString: target object (select)
 */
function setDateTimeFormat(srcString)
{
	if (srcString == "") { return; }
	
	var strResult = "";
	var strTemp = "";
	
	var dtTemp = new Date(srcString);
	var sMon = (dtTemp.getMonth()+1).toString();
	var	sDay = dtTemp.getDate().toString();
	
	if (sMon.length==1) { sMon = "0" + sMon; }
	if (sDay.length==1) { sDay = "0" + sDay; }
	srcString = sMon + "/" + sDay + "/" + dtTemp.getFullYear();
	
	var sHH = dtTemp.getHours().toString();
	var sMM = dtTemp.getMinutes().toString();
	
	if (sHH.length==1) { sHH = "0" + sHH; }
	if (sMM.length==1) { sMM = "0" + sMM; }
	srcString = srcString + " " + sHH + ":" + sMM;
	
	return srcString;
}
/* setOption2Selected: select all item of target object
 * tarObj: target object (select)
 */
function setOption2Selected(tarObj)
{
	if (tarObj == null) { return; }
	
	for(i=0;i<tarObj.length;i++)
		tarObj.options[i].selected = true;
}
function setTreeView(tarId)
{
	var bFlag = (document.all(tarId + "_tab").style.display == "") ? false:true;
	
	if (bFlag) {
		document.all(tarId + "_tab").style.display = "";
		document.all(tarId + "_tree").src = document.all(tarId + "_tree").src.replace(/plus/i,"minus");
		document.all(tarId + "_icon").src = document.all(tarId + "_icon").src.replace(/close/i,"open");
	} else {
		document.all(tarId + "_tab").style.display = "none";
		document.all(tarId + "_tree").src = document.all(tarId + "_tree").src.replace(/minus/i,"plus");
		document.all(tarId + "_icon").src = document.all(tarId + "_icon").src.replace(/open/i,"close");
	}
}
/* getTreeEntityValue: get all selected items, excluding grayout items
 * tarObj: target object (checkbox)
 */
function getTreeEntityValue(tarObj) {
	// get the selected item value
	var strValue = "";
	if (tarObj == null) return strValue;
	if (tarObj.length == null) {
		if (tarObj.checked) {strValue = tarObj.value;}
	} else {
		for (i=0;i<tarObj.length;i++) {
		if (tarObj[i].checked && tarObj[i].style.filter=="") {strValue = strValue + "|" + tarObj[i].value;}
		}
		if (strValue.length>0) {strValue = strValue.slice(1,strValue.length);}
	}
	return strValue;
}
/* setTreeEntityStatus: set the related items to be selected automatically
 * tarObj: target object (checkbox)
 */
function setTreeEntityStatus(tarObj) {
	if (tarObj.length == null) { return; }
	if (event.srcElement.style.filter != "") { event.srcElement.checked = true; }
		
	var sItem;
	var nItem;
	var oItemName = event.srcElement.id.split("|");
	var nItemAll = new Array(oItemName.length-1);
	var nItemSelected = new Array(oItemName.length-1);
	var i, j;
		
	for (i=oItemName.length-1;i>-1;i--) {
		nItemAll[i] = 0;
		nItemSelected[i] = 0;
	}
		
	for (i=tarObj.length-1;i>-1;i--) {
		if (tarObj[i].id.indexOf(event.srcElement.id)>-1) { 
			tarObj[i].checked = event.srcElement.checked;
			tarObj[i].style.filter = "";
			if (tarObj[i].id == event.srcElement.id) {
				nItemAll[oItemName.length-2]++;
				nItemSelected[oItemName.length-2] = (tarObj[i].checked)?nItemSelected[oItemName.length-2]+1:nItemSelected[oItemName.length-2]-1;
			}
		} else {
			sItem = event.srcElement.id.substring(0,event.srcElement.id.lastIndexOf("|",event.srcElement.id.length));
			j = oItemName.length-2;
			while (j>-1) {
				if (tarObj[i].id.indexOf(sItem)>-1) {
					nItemAll[j]++;
					if (tarObj[i].checked) { if (tarObj[i].style.filter=="") {nItemSelected[j]++;} }
					break;
				}
				sItem = sItem.substring(0,sItem.lastIndexOf("|",sItem.length));
				j--;
			}
		}
	}
	for (i=oItemName.length-2;i>-1;i--) {
		sItem = "";
		for (j=i;j>-1;j--) { sItem = oItemName[j] + "|" + sItem; }
		sItem = sItem.substring(0,sItem.length-1);
		nItemAll[i] = nItemAll[i] + nItemAll[i+1];
		nItemSelected[i] = nItemSelected[i] + nItemSelected[i+1];
		if (nItemAll[i+1] == nItemSelected[i+1]) {nItemSelected[i]++;}
		tarObj[sItem].style.filter = "";
		if (nItemSelected[i] == 0) {
			tarObj[sItem].checked = false;
		} else {
			tarObj[sItem].checked = true;
			if (nItemAll[i] != nItemSelected[i]) {
				tarObj[sItem].style.filter = "progid:DXImageTransform.Microsoft.Wave(Add='false', LightStrength=30, Phase=60, Strength=0, Freq=20)";
			}
		}
	}
}
/* getCalendar: pop-up the calendar window and return the selected value
 * tarObj: target object (text)
 */
function getCalendar(tarObj) {
	var sTemp = "";
	var dtTemp;
	var sMon = "";
	var sDay = "";
	
	dtTemp = new Date(tarObj.value);
	if (isNaN(dtTemp)) {dtTemp = new Date();}
	
	sTemp = dtTemp.getFullYear() + "|" + (dtTemp.getMonth()+1) + "|" + dtTemp.getDate();
	rv = window.showModalDialog("../html/calendar.htm",sTemp,"dialogWidth:247px;dialogHeight:225px;center:1;scroll:0;help:0;status:0;resizable=0")
	if (rv!=null && rv!="") {
		try {
			dtTemp = new Date(rv);
			sMon = (dtTemp.getMonth()+1).toString();
			if (sMon.length==1) { sMon = "0" + sMon; }
			sDay = dtTemp.getDate().toString();
			if (sDay.length==1) { sDay = "0" + sDay; }
			tarObj.value = sMon + "/" + sDay + "/" + dtTemp.getFullYear();
		} catch(e) {return;}
	}
}

/* ================================================================================== */
/* COMMON CHECKING FUNCTION                                                           */
/* ================================================================================== */
function checkEmailFromFormat(string,message){
//	SMEX support the domain or email content.
	var re = /^[0-9a-zA-Z@._\-]+$/;
//	var re = /^([\w-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([\w-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/;
	
	if (re.test(string))
		return true;
	if (message.length)
		alert(message);
	return false;	
}
function checkDateTimeFormat(string,message)
{
	try {
		var dtTemp = new Date(string);
		return true;
	} catch(e) {
		if (message.length) alert(message);
		return false;
	}
}
/*
function checkIPAddressFormat(string, message){
	var re = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
	if(re.test(string)) {
		re.exec(string);
		if((RegExp.$1 >= 1) && (RegExp.$1 <= 255) && (RegExp.$2 >= 0) && (RegExp.$2 <= 255) && (RegExp.$3 >= 0) && (RegExp.$3 <= 255) && (RegExp.$4 >= 0) && (RegExp.$4 <= 255) && (string != "0.0.0.0") && (string != "255.255.255.255"))
			return true;
	}
	if(message.length)
		alert(message);
	return false;
}
*/
function checkPortRange(string ,message)
{
    if ( string>=1 && string<=65535 ) return  true;
    if(message.length)
	alert(message);
    return  false;
}

/* ================================================================================== */
/* SMEX 7.0 2004Q3																	  */
/* ================================================================================== */
function jsDisplayStep(tarObj,curItem,nxtItem) {
	// just for multiple items in one page
	if (tarObj.length == null) {return;}
	if (curItem < 0 || curItem > tarObj.length-1) {return;}
	if (nxtItem < 0 || nxtItem > tarObj.length-1) {return;}
	tarObj[curItem].style.display = "none";
	tarObj[nxtItem].style.display = "block";
}

var g_L10NVariables = new Array();
function replaceTdTitle(obj)
{
	for (var i = 0; i< g_L10NVariables.length; ++i)
	{
		for(var j in g_L10NVariables[i])
		{
			if (j == "PAGE_TITLE")
				document.title = g_L10NVariables[i][j];
			else
				obj.setAttribute("title", obj.getAttribute("title").replace("(##" + j + ")", g_L10NVariables[i][j]));
		}
	}
}
function replaceInputValue(obj)
{
	for (var i = 0; i< g_L10NVariables.length; ++i)
	{
		for(var j in g_L10NVariables[i])
		{
			if (j == "PAGE_TITLE")
				document.title = g_L10NVariables[i][j];
			else
				obj.setAttribute("value", obj.getAttribute("value").replace("(##" + j + ")", g_L10NVariables[i][j]));
		}
	}
}
function replaceInnerText(obj)
{
	for (var i = 0; i< g_L10NVariables.length; ++i)
	{
		for(var j in g_L10NVariables[i])
		{
			if (j == "PAGE_TITLE")
				document.title = g_L10NVariables[i][j];
			else
				obj.nodeValue = obj.nodeValue.replace("(##" + j + ")", g_L10NVariables[i][j]);
		}
	}
}

function traverseDomNode(obj)
{
	var _tempNodes = obj.childNodes;
	if(_tempNodes == null || _tempNodes.length == 0)
	{
		return null;
	}
	else
	{
		for(var i=0;i<_tempNodes.length;i++)
		{
			var childNode = _tempNodes[i].childNodes;
			if(childNode == null || childNode.length == 0)	//none composite tag
			{
				if(_tempNodes[i].tagName != null)
				{
					if(_tempNodes[i].tagName.toLowerCase() == "input")
					{
						if((_tempNodes[i].getAttribute("value") != null) && (_tempNodes[i].getAttribute("value").indexOf("(##") != -1))
						{
							replaceInputValue(_tempNodes[i]);
						}
					}
					else if(_tempNodes[i].tagName.toLowerCase() == "td")
					{
						if((_tempNodes[i].getAttribute("title") != null) && (_tempNodes[i].getAttribute("title").indexOf("(##") != -1))
						{
							replaceTdTitle(_tempNodes[i]);
						}
					}
				}
				else if(_tempNodes[i].nodeValue != null)
				{	
					if((_tempNodes[i].nodeValue != null) && (_tempNodes[i].nodeValue.indexOf("(##") != -1))
					{
						replaceInnerText(_tempNodes[i]);
					}
				}
			}
			else	//composite tag
			{
				if((_tempNodes[i].tagName != null))
				{
					if(_tempNodes[i].tagName.toLowerCase() == "td")
					{
						if((_tempNodes[i].getAttribute("title") != null) && (_tempNodes[i].getAttribute("title").indexOf("(##") != -1))
						{
							replaceTdTitle(_tempNodes[i]);
						}
					}
					traverseDomNode(_tempNodes[i]);
				}
			}
		}
	}
}
		
function renderL10NText()
{
	traverseDomNode(document.body);
}