/////////////////////////////////////
// console wrapper for IE
if(navigator.userAgent.indexOf("Firefox") == -1)
{
	var console = Class.create();
  console.info = function () {}
  console.debug = function () {}
  console.warn = function() {}
  console.error = function() {}

};

//
var CEnvelope = Class.create();
CEnvelope.prototype = {
	initialize: function(name) {
		this._xml_cmd_obj = {Envelope:{Body:{}}};
		if(name)
			this.setCommandName(name);
		else
			this._cmd_name = null;
		this._param_name = [];
		this._cmd_result = null;
	},
	setCommandName: function(name) {
		this._cmd_name = name;
		this._xml_cmd_obj.Envelope.Body[this._cmd_name] = new Object();
	},
	getCommandName: function() {
		return this._cmd_name;
	},
	setParam: function(name, xml_obj) {
		this._xml_cmd_obj.Envelope.Body[this._cmd_name][name] = new Object();
		this._xml_cmd_obj.Envelope.Body[this._cmd_name][name] = xml_obj;
		this._param_name.push(name);
	},
	getParamNames: function() {
		return this._param_name;
	},
	getParamByIndex: function(index) {
		return this._xml_cmd_obj.Envelope.Body[this._cmd_name][this._param_name[index]];
	},
	getParamByName: function(name) {
		return this._xml_cmd_obj.Envelope.Body[this._cmd_name][name];		
	},
	isSuccessResult: function(){
		return (this._cmd_result.Return == "true");
	},
	loadXMLDom: function(xml_dom) {
		var xotree = new XML.ObjTree();
		this._xml_cmd_obj  = xotree.parseDOM(xml_dom);
		
		// get command name
		var property;
		for(property in this._xml_cmd_obj.Envelope.Body)
		{
			if(property == "#text")
				continue;
			if(this._xml_cmd_obj.Envelope.Body[property])
			{
				this._cmd_name = property;
				//console.info(this._cmd_name);
				break;
			}
		}
		
		this._param_name.clear();
		// get parameter
		for(property in this._xml_cmd_obj.Envelope.Body[this._cmd_name])
		{
			if(property == "#text")
				continue;
			//console.info(property);
			if(property == "CommandResult")
			{
				this._cmd_result = this._xml_cmd_obj.Envelope.Body[this._cmd_name].CommandResult;
			}else
			{
				//console.info(this._xml_cmd_obj.Envelope.Body[this._cmd_name][property]);
				this._param_name.push(property);
			}
		}
	
		// get parameter
	},
	saveXML: function() {
		var xotree = new XML.ObjTree();
		//console.info(xotree.writeXML(this._xml_cmd_obj));
		return xotree.writeXML(this._xml_cmd_obj);
	}
};
//
//function jsTestCEnvelope()
//{
//	var env = new CEnvelope();
//	env.setCommandName("GetRealTimeMonitorUI");
//	var pars = "xmldata=" + env.saveXML();
//	//console.info(pars);
//	var url = "/smex/cgiDispatcher.exe?Page=port/SMEX_WEB_SERVICES";
//	var myAjax = new Ajax.Request( url, { method: 'post', parameters: pars, asynchronous: false });
//	env.loadXMLDom(myAjax.transport.responseXML.documentElement);
//	
//	var data = env.getParamByName("RealTimeMonitorUI");
//	var names = env.getParamNames();
//	//console.info(names);
//	var data2 = env.getParamByIndex(0);
//	//console.info(data2);
//	
//	if(env.isSuccessResult())
//	{
//		//alert("ok");
//		//alert(data.ServerInfo.ServerName);
//	}
//}
//function jsTestAsyncEnvelope()
//{
//	var env = new CEnvelope("GetRealTimeMonitorUI");
//	var pars = "xmldata=" + env.saveXML();
//	var url = "/smex/cgiDispatcher.exe?Page=port/SMEX_WEB_SERVICES";
//	var myAjax = new Ajax.Request( url, { method: 'post', parameters: pars, onComplete: jsEnvelopeDone });
//
//}
//
//function jsEnvelopeDone(originalRequest)
//{
//	var env = new CEnvelope;
//	env.loadXMLDom(originalRequest.responseXML.documentElement);
//	if(env.isSuccessResult())
//	{
//		var data = env.getParamByName("RealTimeMonitorUI");
//		alert(data.ServerInfo.ServerName);
//	}
//}

/////////////////////
// Helper wrapper library
var CADSites = Class.create();
CADSites.prototype = {
  initialize: function() {
  	this._sites = [];
  },
  addServer: function(site, server) {
  	if(this._sites[site] == null || this._sites[site] == undefined)
  		this._sites[site] = [];
  	
  	this._sites[site].push(server);
  },
  getServers: function(site) {
  	return this._sites[site];
  },
  getSites: function() {
  	return $H(this._sites).keys();
  }
};

var CAdminGroups = Class.create();
CAdminGroups.prototype = {
	initialize: function() {
		this._adminGroup = [];
		this._allServers = [];
	},
	addServer: function(group, server) {
		if(this._adminGroup[group] == null || this._adminGroup[group] == undefined)
			this._adminGroup[group] = [];
		this._adminGroup[group].push(server);
		this._allServers.push(server);
	},
	getServers: function(group) {
		return this._adminGroup[group];
	},
	getAdminGroups: function() {
		return $H(this._adminGroup).keys();
	},
	getAllServers: function() {
		return this._allServers;
	}
};

/////////////////////////////////////
// Helper function

// Convert single element to array type.
function jsChangeToArray(val) {
	if(typeof(val) == "undefined" || val == null) {
		var result = [];
		return result;
	}else if(typeof(val) == "object" && val.constructor == Array) {
		return val;
	}else {
		var result = [];
		result.push(val);
		return result;
	}
}

//////////////////////////////////////
//

var cmd_agent_update_task_id 			= 0;
var cmd_agent_replication_task_id	= 1;
CCmdAgent = new Class.create();
CCmdAgent.prototype = {
	initialize : function(task_id) {
		// init supported command
		this._cmd_param_map = [];
		this._cmd_param_map[cmd_agent_update_task_id] = {
			cmd_name:		"RunManualUpdateTask",
			param:			"ManualUpdateTask",
			query_name:	"CheckManualUpdateTask",
			query_param:"ManualUpdateTask"
		};
		this._cmd_param_map[cmd_agent_replication_task_id] = {
			cmd_name:		"RunReplicationTask",
			param:			"ReplicationTask",
			query_name:	"CheckReplicationTaskStatus",
			query_param:"ReplicationTask"
		};

		this._cmd_name = this._cmd_param_map[task_id].cmd_name;
		this._param_name = this._cmd_param_map[task_id].param;
		this._query_cmd_name = this._cmd_param_map[task_id].query_name;
		this._query_param = this._cmd_param_map[task_id].query_param;
		this._task_info = null;
	},
	execute: function() {
		var bRet = false;
		var envelope = new CEnvelope(this._cmd_name);
		var result_env = this._sendRequest(envelope);
		if(result_env.isSuccessResult())
		{
			var param_obj = result_env.getParamByName(this._param_name);
			this._task_info = param_obj.TaskInfo;
			if(this._task_info.Result == "true")
				bRet = true;
		}
		return bRet;
	},
	executeWithParam: function(xml_obj) {
		var bRet = false;
		var envelope = new CEnvelope(this._cmd_name);
		envelope.setParam(this._param_name, xml_obj);
		var result_env = this._sendRequest(envelope);
		if(result_env.isSuccessResult())
		{
			var param_obj = result_env.getParamByName(this._param_name);
			if(param_obj)
			{
				this._task_info = param_obj.TaskInfo;
				if(this._task_info.Result == "true")
					bRet = true;
			}
		}
		return bRet;
	},
	// return 1 mean in-progress, return 0 mean success, return -1 means fail.
	queryStatus: function(callback) {
		var ret = 1;
		var envelope = new CEnvelope(this._query_cmd_name);
		var query_param_obj = new Object();
		query_param_obj.TaskInfo = new Object();
		query_param_obj.TaskInfo.TrackingId = this._task_info.TrackingId;
		envelope.setParam(this._query_param, query_param_obj);
		var result_env;
		if(callback)
		{
		 	result_env = this._sendAsyncRequest(envelope, callback);
			ret = 1;
		} 	
		else
		{
			result_env = this._sendRequest(envelope);
			
			if(result_env.isSuccessResult())
			{
				var param_obj = result_env.getParamByName(this._query_param);
				this._task_info = param_obj.TaskInfo;
				if(this._task_info && this._task_info.Result == "true")
				{
					if(this._task_info.Stage == "InProgress")
						ret = 1;
					else if(this._task_info.Stage == "Success")
						ret = 0;
					else
						ret = -1;
				}else
					ret = -1;
				//console.info("taskid = %s, result=%s, status=%s, stage=%s", 
				//	this._task_info.TrackingId, this._task_info.Result, this._task_info.Status, this._task_info.Stage);
			}
		}
		return ret;
	},
	
	// private function
	_sendRequest: function(env) {
		var pars = "xmldata=" + env.saveXML();
		console.info("request param=\n%s", pars);
		var url = "/smex/cgiDispatcher.exe?Page=port/SMEX_WEB_SERVICES";
		var myAjax = new Ajax.Request( url, { method: 'post', parameters: pars, asynchronous: false });
		var result_env = new CEnvelope();
		console.info("responseText=\n%s", myAjax.transport.responseText);
		result_env.loadXMLDom(myAjax.transport.responseXML.documentElement);
		return result_env;
	},
	_sendAsyncRequest: function(env) {
		var pars = "xmldata=" + env.saveXML();
		console.info("request param=\n%s", pars);
		var url = "/smex/cgiDispatcher.exe?Page=port/SMEX_WEB_SERVICES";
		var myAjax = new Ajax.Request( url, { method: 'post', parameters: pars, onComplete: this.done.bind(this) });
	},
	done: function(originalRequest) {
		var ret = 1;
		var result_env = new CEnvelope();
		console.info("responseText=\n%s", originalRequest.responseText);
		result_env.loadXMLDom(originalRequest.responseXML.documentElement);
		if(result_env.isSuccessResult())
		{
			var param_obj = result_env.getParamByName(this._query_param);
			this._task_info = param_obj.TaskInfo;
			if(this._task_info && this._task_info.Result == "true")
			{
				if(this._task_info.Stage == "InProgress"){
					$("replicate_stage").innerHTML = "In progress:" + this._task_info.Status;
					ret = 1;
				}else if(this._task_info.Stage == "Success"){
					$("replicate_stage").innerHTML = "Success:" + this._task_info.Status;
					ret = 0;
				}else {
					$("replicate_stage").innerHTML = "Fail:" + this._task_info.Status;
					ret = -1;
				}
			}else
				ret = -1;
			//console.info("taskid = %s, result=%s, status=%s, stage=%s", 
			//	this._task_info.TrackingId, this._task_info.Result, this._task_info.Status, this._task_info.Stage);
		}
		if(ret == 1)
			this.queryStatus(this.done);
	}
}
function jsTestUpdateTask()
{
	var cmd_agent = new CCmdAgent(cmd_agent_update_task_id);
	if(cmd_agent.execute())
	{
		//console.info("execute ok");
		if(cmd_agent.queryStatus(cmd_agent.done))
		{
			//console.info("queryStatus ok");
		}
	}
}

function jsTestReplicationTask(servers)
{
	var cmd_agent = new CCmdAgent(cmd_agent_replication_task_id);
	var param_obj = new Object();
	param_obj.ReplicationOption = new Object();
	param_obj.ReplicationOption.ServerList = new Object();
	param_obj.ReplicationOption.ServerList.ServerName = servers;
	param_obj.ReplicationOption.ConfigSelection = new Object();
	param_obj.ReplicationOption.ConfigSelection.SelectionType = "SelectAll";
	param_obj.ReplicationOption.ConfigSelection.SelectSpecified = new Object();
	param_obj.ReplicationOption.ConfigSelection.SelectSpecified.VirusScan = "true";
	param_obj.ReplicationOption.ConfigSelection.SelectSpecified.FileBlocking = "true";
	param_obj.ReplicationOption.ConfigSelection.OverwriteServerDependentSettings = "true";
	if(cmd_agent.executeWithParam(param_obj))
	{
		if(cmd_agent.queryStatus(cmd_agent.done))
		{
			//console.info("queryStatus ok");
		}
	}//else
		//console.info("executeWithParam fail");
}


