<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" version="1.0" encoding="UTF-8" indent="yes"/>

	<xsl:template match="data[@name='report_item_content_summary']">
		<table width="100%" border="0" cellpadding="0" cellspacing="0" class="border">
			<thead>
				<tr>
					<td class="tableheader" colspan="4"><xsl:value-of select="$localization[@name=current()/@name]"/></td>
				</tr>
				<tr>
					<td class="grey" width="38%"><xsl:value-of select="$localization[@name='activities']"/></td>
					<td class="grey" width="20%" align="right"><xsl:value-of select="$localization[@name='frequency']"/></td>
					<td class="grey-end" width="20%" align="right"><xsl:value-of select="$localization[@name='percentage']"/></td>
					<td class="grey-end"        ><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
				</tr>
			</thead>
			<tbody>
				<tr>
					<td class="data1b"><xsl:value-of select="$localization[@name='total_message_count']"/></td>
					<td class="data1b" align="right"><xsl:value-of select="datarow/@total_message_count"/></td>
					<td class="data1" ><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
					<td class="data1" ><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
				</tr>
				<tr>
					<td class="data2b"><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
						<xsl:value-of select="$localization[@name='content_filtered_count']"/></td>
					<td class="data2b" align="right"><xsl:call-template name="format_number"><xsl:with-param name="num" select="datarow/@content_filtered_count"/></xsl:call-template></td>
					<td class="data2" align="right">
						<xsl:call-template name="format_percentage">
							<xsl:with-param name="numerator" select="datarow/@content_filtered_count"/>
							<xsl:with-param name="denominator" select="datarow/@total_message_count"/></xsl:call-template></td>
					<td class="data2" ><xsl:value-of select="$localization[@name='of_scaned_total']"/></td>
				</tr>
			</tbody>
		</table>
	</xsl:template>

</xsl:stylesheet>
