<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:include href="report_common.xslt"/>
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	<xsl:variable name="localization" select="document('localization.xml')/strings/group[@name='report']//string"/>

	<xsl:template match="data[@render_info='chart.curve.2']">
		<chart>
			<data>
				<num_of_series>1</num_of_series>
				<labels>
					<xsl:for-each select="datarow">
						<xsl:apply-templates select="."/>
					</xsl:for-each>
					<xsl:if test="count(datarow) = 1">
						<xsl:apply-templates select="datarow"/>
					</xsl:if>
				</labels>
				<series>
					<xsl:attribute name="name"><xsl:value-of select="$localization[@name=name(current()/datarow/@*[2])]"/></xsl:attribute>
					<xsl:for-each select="//datarow/@*[2]">
						<value><xsl:value-of select="."/></value>
					</xsl:for-each>
					<xsl:if test="count(datarow) = 1">
						<value><xsl:value-of select="datarow/@*[2]"/></value>
					</xsl:if>
				</series>
			</data>
		</chart>
	</xsl:template>

	<xsl:template match="data[@render_info='chart.curve.3']">
		<chart>
			<data>
				<num_of_series>2</num_of_series>
				<labels>
					<xsl:for-each select="datarow">
						<xsl:apply-templates select="."/>
					</xsl:for-each>
					<xsl:if test="count(datarow) = 1">
						<xsl:apply-templates select="datarow"/>
					</xsl:if>
				</labels>
				<series>
					<xsl:attribute name="name"><xsl:value-of select="$localization[@name=name(current()/datarow/@*[2])]"/></xsl:attribute>
					<xsl:for-each select="//datarow/@*[2]">
						<value><xsl:value-of select="."/></value>
					</xsl:for-each>
					<xsl:if test="count(datarow) = 1">
						<value><xsl:value-of select="datarow/@*[2]"/></value>
					</xsl:if>
				</series>
				<series>
					<xsl:attribute name="name"><xsl:value-of select="$localization[@name=name(current()/datarow/@*[3])]"/></xsl:attribute>
					<xsl:for-each select="//datarow/@*[3]">
						<value><xsl:value-of select="."/></value>
					</xsl:for-each>
					<xsl:if test="count(datarow) = 1">
						<value><xsl:value-of select="datarow/@*[3]"/></value>
					</xsl:if>
				</series>
			</data>
		</chart>
	</xsl:template>

	<xsl:template match="data[@render_info='chart.curve.4']">
		<chart>
			<data>
				<num_of_series>3</num_of_series>
				<labels>
					<xsl:for-each select="datarow">
						<xsl:apply-templates select="."/>
					</xsl:for-each>
					<xsl:if test="count(datarow) = 1">
						<xsl:apply-templates select="datarow"/>
					</xsl:if>
				</labels>
				<series>
					<xsl:attribute name="name"><xsl:value-of select="$localization[@name=name(current()/datarow/@*[2])]"/></xsl:attribute>
					<xsl:for-each select="//datarow/@*[2]">
						<value><xsl:value-of select="."/></value>
					</xsl:for-each>
					<xsl:if test="count(datarow) = 1">
						<value><xsl:value-of select="datarow/@*[2]"/></value>
					</xsl:if>
				</series>
				<series>
					<xsl:attribute name="name"><xsl:value-of select="$localization[@name=name(current()/datarow/@*[3])]"/></xsl:attribute>
					<xsl:for-each select="//datarow/@*[3]">
						<value><xsl:value-of select="."/></value>
					</xsl:for-each>
					<xsl:if test="count(datarow) = 1">
						<value><xsl:value-of select="datarow/@*[3]"/></value>
					</xsl:if>
				</series>
				<series>
					<xsl:attribute name="name"><xsl:value-of select="$localization[@name=name(current()/datarow/@*[4])]"/></xsl:attribute>
					<xsl:for-each select="//datarow/@*[4]">
						<value><xsl:value-of select="."/></value>
					</xsl:for-each>
					<xsl:if test="count(datarow) = 1">
						<value><xsl:value-of select="datarow/@*[4]"/></value>
					</xsl:if>
				</series>
			</data>
		</chart>
	</xsl:template>

	<xsl:template match="data[@frequence = 'HOURLY']/datarow">
		<label>
			<xsl:call-template name="format_datehour_string">
				<xsl:with-param name="datetime_string" select="@datetime_first"/>
			</xsl:call-template>
		</label>
	</xsl:template>

	<xsl:template match="data[@frequence = 'DAILY']/datarow">
		<label>
			<xsl:call-template name="format_date_string">
				<xsl:with-param name="datetime_string" select="@datetime_first"/>
			</xsl:call-template>
		</label>
	</xsl:template>

	<xsl:template match="data[@frequence = 'WEEKLY']/datarow | data[@frequence = 'MONTHLY']/datarow">
		<label>
			<xsl:call-template name="format_date_string">
				<xsl:with-param name="datetime_string" select="@datetime_first"/>
			</xsl:call-template>
			<xsl:text> - </xsl:text>
			<xsl:call-template name="format_date_string">
				<xsl:with-param name="datetime_string" select="@datetime_last"/>
			</xsl:call-template>
		</label>
	</xsl:template>

</xsl:stylesheet>
