﻿<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>


  <!--|| TEMPLATE : Web Reputation summary items ||-->
  <xsl:template match="data[@name='report_item_url_summary']">
    <table width="100%" border="0" cellpadding="0" cellspacing="0" class="border">
      <thead>
        <tr>
          <td class="tableheader" colspan="4">
            <xsl:value-of select="$localization[@name=current()/@name]"/>
          </td>
        </tr>
        <tr>
          <td class="grey"     width="30%">
            <xsl:value-of select="$localization[@name='activities']"/>
          </td>
          <td class="grey"     width="20%" align="right">
            <xsl:value-of select="$localization[@name='frequency']"/>
          </td>
          <td class="grey-end" width="20%" align="right">
            <xsl:value-of select="$localization[@name='percentage']"/>
          </td>
          <td class="grey-end" width="30%">
            <xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
          </td>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td class="data1b">
            <xsl:value-of select="$localization[@name='total_url_count']"/>
          </td>
          <td class="data1b" align="right">
            <xsl:value-of select="datarow/@total_message_count"/>
          </td>
          <td class="data1"  align="right"></td>
          <td class="data1" ></td>
        </tr>
        <tr>
          <td class="data2b">
            <xsl:value-of select="$localization[@name='suspicious_url_count']"/>
          </td>
          <td class="data2b" align="right">
            <xsl:value-of select="datarow/@suspicious_url_count"/>
          </td>
          <td class="data2"  align="right">
            <xsl:call-template name="format_percentage">
              <xsl:with-param name="numerator" select="datarow/@suspicious_url_count"/>
              <xsl:with-param name="denominator" select="datarow/@total_message_count"/>
            </xsl:call-template>
          </td>
          <td class="data2" >
            <xsl:value-of select="$localization[@name='of_total_url']"/>
          </td>
        </tr>
      </tbody>
    </table>
  </xsl:template>


</xsl:stylesheet>
