//
function trim(s)
{
	var len = s.length;
	if (len == 0)
		return s;
		
	var idxLeft = 0, idxRight = len - 1;
	
	// trim left
	var i = idxLeft;
	while (i < len)
	{
		var ch = s.charAt(i);
		if (ch != " " && ch != "\t")
			break;
		i++;
	}
	if (i < len)
		idxLeft = i;
	
	// trim right
	i = idxRight;
	while (i > idxLeft)
	{
		var ch = s.charAt(i);
		if (ch != " " && ch != "\t")
			break;
		--i;
	}
	if (i > idxLeft)
		idxRight = i;

	return s.substring(idxLeft, idxRight+1);
}

// map of digital asset id
function IDMap(oldId, newId)
{
	this.oldId = oldId;
	this.newId = newId;
}
//updated DLP policy
function PolicyMap(PolicyId, newValue)
{
	this.PolicyId = PolicyId;
	this.newValue = newValue;  //new template list value
}

var fso = new ActiveXObject("Scripting.FileSystemObject");
var DBProfile = WScript.Arguments.length > 0 ? WScript.Arguments(0) : "";
var operation   = WScript.Arguments.length > 1 ? WScript.Arguments(1) : "create";
var SQLServerPassword = WScript.Arguments.length > 2 ? WScript.Arguments(2) : "";
var DLPBackupXml = "DlpDataBackup4CTL31.xml";
var DLPKeywordBackupXml = "DlpKeywordBackup4CTL31.xml";
var DLPExpressBackupXml = "DlpExpressionBackup4CTL31.xml";

WScript.StdOut.WriteLine("");
WScript.StdOut.WriteLine("--------------------------log started------------------------------");
var currentDate = new Date();
WScript.StdOut.WriteLine(currentDate);
WScript.StdOut.WriteLine("");		
WScript.Echo("DBProfile:" + DBProfile);
WScript.Echo("operation:" + operation);

if(SQLServerPassword == "{SQLSERVERPASSWORD}")
{
	SQLServerPassword = "";
}

if (fso.FileExists(DBProfile))
{
    try
    {
          
        DBProfile = fso.GetAbsolutePathName(DBProfile);
        var sWorkingDirectory = fso.GetParentFolderName(DBProfile);
 		WScript.Echo("sWorkingDirectory:" + sWorkingDirectory);
        var dbProfile = new DatabaseProfile(DBProfile, sWorkingDirectory);
        if (operation == "create")
            dbProfile.CreateDatabase();
        else if(operation == "rollback")
            dbProfile.RollbackDatabase();
        else if (operation == "install-scripts")
            dbProfile.CreateInstallSqlStatements();
        else if (operation == "upgrade-scripts")
            dbProfile.CreateUpgradeSqlStatements();
        else if (operation == "rollback-scripts")
            dbProfile.CreateRollbackSqlStatements();
        else if (operation == "switch-dbfile")
       	    dbProfile.SwitchDBFile();
		else if (operation == "test-connection")
			dbProfile.TestConnection();
   	    try{
   	        fso.CreateTextFile(dbProfile.HomeDir+"\\InstallDBFinish.lck");
   	    }catch(e)
   	    {
   	    	WScript.StdErr.WriteLine("fso.CreateTextFile fail");
   	        WScript.StdErr.WriteLine( e.message + " (" +  e.number + ") ");       	        
   	    }       	
    }
    catch(e)
    {
    	WScript.StdErr.WriteLine("catch exception in the outest catch");
        WScript.StdErr.WriteLine(e.message + " (" +  e.number + ") ");
        WScript.Quit(e.number);
    }
}
else
{
    WScript.StdErr.WriteLine("A valid database profile is needed. Your input is \"" + DBProfile + "\"");
    WScript.StdErr.WriteLine("Usage: CScript //E:JavaScript dbDatabaseCreation.js DATABASE-PROFILE-NAME [create(default)|install-scripts|upgrade-scripts]");
    WScript.Quit(1);
}


function DatabaseProfile(filename, sWorkingDirectory)
{
    var log = new Log(true);
    var logUpgradeSchema = new Log(false);
    var fso = new ActiveXObject("Scripting.FileSystemObject");
    var xProfile = XDoc();
    xProfile.load(filename);
    
  

    this.WorkingDirectory = sWorkingDirectory;

    this.Type = xProfile.selectSingleNode("/database_configuration/database_type").text;
    this.Host = xProfile.selectSingleNode("/database_configuration/database_host").text;
    this.Name = xProfile.selectSingleNode("/database_configuration/database_name").text;
    this.File = xProfile.selectSingleNode("/database_configuration/database_file").text;
    this.HomeDir = xProfile.selectSingleNode("/database_configuration/product_home_dir").text;
    WScript.Echo("database_type:" + this.Type);
    WScript.Echo("database_host:" + this.Host);
    WScript.Echo("database_name:" + this.Name);
    WScript.Echo("database_file:" + this.File);
    WScript.Echo("product_home_dir:" + this.HomeDir);
    this.IsInstalled = true;   // FOR SMEX 10 SP1 installation only
   

    this.ConnectStringForInstall = xProfile.selectSingleNode("/database_configuration/database_initialization/connect_string[@for='install']").text;
    this.ConnectStringForOperate = xProfile.selectSingleNode("/database_configuration/database_initialization/connect_string[@for='operate']").text;
	WScript.Echo("ConnectStringForInstall:" + this.ConnectStringForInstall);
	WScript.Echo("ConnectStringForOperate:" + this.ConnectStringForOperate);
    if(this.Type != "JET")
	{
	    this.ConnectStringForOperate += SQLServerPassword;
	    this.IsSeperateSQLServer = xProfile.selectSingleNode("/database_configuration/database_is_seperate_sql_server").text;
	    this.SecurityString = xProfile.selectSingleNode("/database_configuration/database_security_string").text;
	    this.UserId = xProfile.selectSingleNode("/database_configuration/database_userid").text;
	}	    
    

   
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.CreateDatabase = function ()
    {
    	WScript.Echo("Enter CreateDatabase");	
        var conn = new ActiveXObject("ADODB.Connection");
        

        if (this.Type == "JET")
        {
            var jetEngine = new ActiveXObject("JRO.JetEngine");
            jetEngine.CompactDatabase("Data Source = " + this.File, "Data Source = " + this.File + ".bak");
          
            var file = new ActiveXObject("Scripting.FileSystemObject");
            file.DeleteFile(this.File);
            file.MoveFile(this.File + ".bak", this.File);
        }
        
        var ConnectString = this.ConnectStringForOperate;
        WScript.Echo("conn.Open");
       	conn.Open(ConnectString);
		
		//add transaction
	    WScript.Echo("conn.BeginTrans");	
		conn.BeginTrans();
		
        function SqlScriptIterator(sqlInstallScript, bHaltOnError)
        {
            try
            {
            	sqlInstallScript=sqlInstallScript.replace(/\n/g,"\r\n");
            	log.Write(sqlInstallScript);
                conn.Execute(sqlInstallScript);
            }
            catch(e)
            {
                if (bHaltOnError)
                {
                    throw e;
                }
                else
                {
                	WScript.Echo("catch exception in CreateDatabase:SqlScriptIterator");
					log.Write(sqlInstallScript);
                	log.Write("Expected error: ", e.message, " (", e.number, ") ");
                }

            }
            return true;
        }
		
	    try
		{
			WScript.StdOut.WriteLine("begin upgrade tables");
			this.GetUpgradeScripts(SqlScriptIterator, conn);
		}
		catch(e)
		{
			WScript.Echo("catch exception in CreateDatabase, RollbackTrans now");	
			conn.RollbackTrans();
			conn.Close();
			throw e;
		}
		WScript.Echo("conn.CommitTrans");
		conn.CommitTrans();
		conn.Close();
		WScript.Echo("Leave CreateDatabase");
    }
    
	///////////////////////////////////////////////////////////////////////////////////////////////
	this.TestConnection = function()
	{
		WScript.Echo("Enter TestConnection");
		try
		{
			var conn = new ActiveXObject("ADODB.Connection");
			var ConnectString = this.ConnectStringForOperate;
			WScript.Echo("conn.Open");
			conn.Open(ConnectString);
			conn.Close();
		}
		catch(e)
		{
			WScript.Echo("catch exception in TestConnection");
			throw e;
		}
		WScript.Echo("Leave TestConnection");
	}
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.RollbackDatabase = function()
    {
		WScript.Echo("Enter RollbackDatabase");
		var conn = new ActiveXObject("ADODB.Connection");
		
        if (this.Type == "JET")
        {
            var jetEngine = new ActiveXObject("JRO.JetEngine");
            jetEngine.CompactDatabase("Data Source = " + this.File, "Data Source = " + this.File + ".bak");
          
            var file = new ActiveXObject("Scripting.FileSystemObject");
            file.DeleteFile(this.File);
            file.MoveFile(this.File + ".bak", this.File);
        }
        
        var ConnectString = this.ConnectStringForOperate;
        WScript.Echo("conn.Open");
       	conn.Open(ConnectString);
		
		//add transaction
		WScript.Echo("conn.BeginTrans");
		conn.BeginTrans();
		
        function SqlScriptIterator(sqlInstallScript, bHaltOnError)
        {
            try
            {
            	sqlInstallScript=sqlInstallScript.replace(/\n/g,"\r\n");
                conn.Execute(sqlInstallScript);
                log.Write(sqlInstallScript);
            }
            catch(e)
            {
                if (bHaltOnError)
                {
                    throw e;
                }
                else
                {
                    WScript.Echo("catch exception in RollbackDatabase:SqlScriptIterator");
					log.Write(sqlInstallScript);
                    log.Write("Expected error: ", e.message, " (", e.number, ") ");
                }

            }
            return true;
        }
		
        try
		{
			WScript.StdOut.WriteLine("begin rollback tables");
			this.GetRollbackScripts(SqlScriptIterator, conn);
		}
		catch(e)
		{
			WScript.Echo("catch exception in RollbackDatabase, RollbackTrans now");	
			conn.RollbackTrans();
			conn.Close();
			throw e;
		}
		WScript.Echo("conn.CommitTrans");
		conn.CommitTrans();
		conn.Close();
		WScript.Echo("Leave RollbackDatabase");
    };
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.CreateInstallSqlStatements = function ()
    {
    	WScript.Echo("Enter CreateInstallSqlStatements");
        function SqlScriptIterator(sqlInstallScript, bHaltOnError)
        {
            log.Write(sqlInstallScript);
            log.Write("GO");
            log.Write("");
            return true;
        }
        this.GetInstallScripts(SqlScriptIterator);
        WScript.Echo("Leave CreateInstallSqlStatements");
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.CreateUpgradeSqlStatements = function ()
    {
    	WScript.Echo("Enter CreateUpgradeSqlStatements");
        function SqlScriptIterator(sqlInstallScript, bHaltOnError)
        {
            log.Write(sqlInstallScript);
            log.Write("GO");
            log.Write("");
            return true;
        }
        this.GetUpgradeScripts(SqlScriptIterator);
        WScript.Echo("Leave CreateUpgradeSqlStatements");
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.CreateRollbackSqlStatements = function ()
    {
    	WScript.Echo("Enter CreateRollbackSqlStatements");
        function SqlScriptIterator(sqlInstallScript, bHaltOnError)
        {
            log.Write(sqlInstallScript);
            log.Write("GO");
            log.Write("");
            return true;
        }
        this.GetRollbackScripts(SqlScriptIterator, null);
        WScript.Echo("Leave CreateRollbackSqlStatements");
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.SwitchDBFile = function()
    {
    	WScript.Echo("Enter SwitchDBFile");
    	if(this.Type == "SQLSVR" && WScript.Arguments.length>2)
    	{
    		var sNewFile = WScript.Arguments(2);
    		var conn = new ActiveXObject("ADODB.Connection");

            conn.Open("Provider=SQLOLEDB.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=master;Data Source=" + this.Host);
            conn.Execute("USE master");
            try
            {
                conn.Execute("DROP DATABASE [" + this.Name + "]");
            }
            catch(e)
            {
            	                
            }
            
            conn.Execute("CREATE DATABASE [" + this.Name + "] ON ( FILENAME = " + sNewFile + ".mdf' ), ( FILENAME = " + sNewFile + ".ldf ) FOR ATTACH");      
            conn.Execute("ALTER  DATABASE [" + this.Name + "] SET AUTO_SHRINK ON");
	        
            conn.Close();               		
    	}
    	WScript.Echo("Leave SwitchDBFile");
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.GetInstallScripts = function (visitor)
    {
    	WScript.Echo("Enter GetInstallScripts");
        var fSqlSatementCreation     = sWorkingDirectory + "\\" + "dbTableCreationSql4SP1.xslt";
        var xDatabaseInstallSql      = XDoc();
        var xDatabaseSchemaTransform = XDoc();
        xDatabaseSchemaTransform.load(fSqlSatementCreation);
         WScript.Echo("after xDatabaseSchemaTransform.load");
        xDatabaseInstallSql.loadXML(xProfile.transformNode(xDatabaseSchemaTransform));
        var xSqlScriptsList = xDatabaseInstallSql.selectNodes("/database/database_installation/sql");
        var xSql = null;
        while (xSqlScriptsList && (xSql = xSqlScriptsList.nextNode()))
        {
            if (!visitor(xSql.text))
                break;
        }
        
        WScript.Echo("Leave GetInstallScripts");
    }
    
    this.ImportDLPData = function(visitor, cn)
    {
    	if (this.Name.substr(0, 4) != "Conf")
        {
        	WScript.Echo("Not config db, skipped importing dlp data");
        	return;
        }
        
        if (false)
        {
        	if (cn != null)
        	{
	        	var rs = cn.Execute("SELECT COUNT(*) FROM TM_DLPFilterKeyword");
	        	var keywordCount = rs(0).Value;
	        	rs.Close();
	        	
	        	if (keywordCount > 1)
	        	{
	        		WScript.Echo("dlp keyword record count: " + keywordCount + ", skip importing");
	        		return;
	        	}
	        	WScript.Echo("dlp keyword record count: " + keywordCount);
	        }
        }

        WScript.Echo("Is config db, importing dlp data...");
        
    	var comp = new ActiveXObject("MSXML2.DOMDocument");
    	var xml_path = sWorkingDirectory + "\\Compliance_Template.xml";
    	WScript.Echo("loading " + xml_path + " ...");
		var loaded = comp.load(xml_path);
		
		if (loaded)
		{
			WScript.Echo("load success");
			this.GetDLPKeywordInstallScripts(comp, visitor,cn);
			this.GetDLPExpressionInstallScripts(comp, visitor,cn);
			this.GetDLPTemplateInstallScripts(comp, visitor, cn);
		}
		else
			WScript.Echo("load failed");
    }
    
    this.GetDLPKeywordInstallScripts = function(dom, visitor,cn)
    {
	    // backup dlp keyword to xml file
		if (cn != null)
		{
			// backup templates
			var dom_temp = new ActiveXObject("MSXML2.DOMDocument");
			dom_temp.loadXML("<dlp><keywords/><keywordMgr/></dlp>");
			var keywordsNode = dom_temp.selectSingleNode("/dlp/keywords");
			
			var sql = "SELECT CFG_INDEX,CFG_DEFAULT_INSTANCE,DLP_KEYWORD_NAME,DLP_KEYWORD_INTERNALNAME," +
				"DLP_KEYWORD_DESC,DLP_KEYWORD_CONDITION,DLP_KEYWORD_THRESHOLD,DLP_KEYWORD_NUMBER,"+
				"DLP_KEYWORD_MODIFIED,DLP_KEYWORD_BUILTIN,DLP_SUBKEYWORD_LIST FROM TM_DLPFilterKeyword WHERE " +
				"CFG_INDEX<>'SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_KEYWORD_DEFAULT'";
			var rs = cn.Execute(sql);
			while (!rs.EOF)
			{
				var keyword = dom_temp.createElement("keyword");
				keyword.setAttribute("cfg_index", rs(0).Value);
				keyword.setAttribute("def_instance", rs(1).Value);
				keyword.setAttribute("name", rs(2).Value);
				keyword.setAttribute("internalname", rs(3).Value);
				keyword.setAttribute("description", rs(4).Value);
				keyword.setAttribute("condition", rs(5).Value);
				keyword.setAttribute("threshold", rs(6).Value);
				keyword.setAttribute("number", rs(7).Value);
				keyword.setAttribute("modify", rs(8).Value);
				keyword.setAttribute("builtin", rs(9).Value);
				keyword.text = rs(10).Value;
				keywordsNode.appendChild(keyword);
				
				rs.MoveNext();
			}
			rs.Close();
			
			// backup mgr table
			var mgrNode = dom_temp.selectSingleNode("/dlp/keywordMgr");
			sql = "SELECT CFG_INDEX,CFG_DLP_KEYWORD_LIST_CFGSETTING_MV FROM TM_DLPFilterKeywordMgr";
			rs = cn.Execute(sql);
			while (!rs.EOF)
			{
				var mgr = dom_temp.createElement("mgr");
				mgr.setAttribute("cfg_index", rs(0).Value);
				mgr.text = rs(1).Value;
				mgrNode.appendChild(mgr);
				
				rs.MoveNext();
			}
			rs.Close();
			
			dom_temp.save(sWorkingDirectory + "\\" + DLPKeywordBackupXml);
		}
	    // delete built-in keywords
		var sql = "DELETE FROM TM_DLPFilterKeyword WHERE DLP_KEYWORD_BUILTIN=" + ((this.Type == "SQLSVR") ? "1" : "True");
		visitor(sql, true);
		
		var allUsrCfgIndexes = "";
		var allDefCfgIndexes = "";
		//get customize keyword index	
		if (cn != null)
		{
			var indexPrefix = "SMEX_PLC_NULL:";
			var rs = cn.Execute("SELECT CFG_INDEX FROM TM_DLPFilterKeyword where CFG_INDEX!='SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_KEYWORD_DEFAULT'");
	        
	        while (!rs.EOF)
	        {
	        	var cfgIndex = rs(0).Value;
	            allUsrCfgIndexes += "TM_DLPFilterKeyword:" + cfgIndex.substr(indexPrefix.length) + ":";  
		        rs.MoveNext();
	        }
			rs.Close();
		}
		
    	var keywords = dom.selectNodes("/SAPolicy/digitalAssets/dictionary");
		var uniPref = (this.Type == "SQLSVR") ? "N" : "";
		
		for (var i=0; i<keywords.length; ++i)
		{
			var internalName = keywords[i].attributes.getNamedItem("name").text;
			var cfgIndex = "SMEX_SUB_CFG_DLP_KEYWORD" + internalName;
			allDefCfgIndexes += "TM_DLPFilterKeyword:" + cfgIndex + ":";
			var displayName = keywords[i].attributes.getNamedItem("display_name").text.replace(/'/g, "''");
			var desc = keywords[i].attributes.getNamedItem("description").text.replace(/'/g, "''");
			var condition = keywords[i].attributes.getNamedItem("type").text;
			var thresholdNode = keywords[i].attributes.getNamedItem("threshold");
			var threshold = thresholdNode == null ? 0 : thresholdNode.text;
			var numberNode = keywords[i].attributes.getNamedItem("number");
			var number = numberNode == null ? 0 : numberNode.text;
			var builtin = keywords[i].attributes.getNamedItem("pre-defined").text;
			if (this.Type == "SQLSVR")
				builtin = (builtin == "true") ? 1 : 0;
			else
				builtin = (builtin == "true") ? "True" : "False";
			var subKeywordsXml = keywords[i].xml.replace(/'/g, "''");
		
			if (!visitor("INSERT INTO TM_DLPFilterKeyword (CFG_INDEX, CFG_DEFAULT_INSTANCE, DLP_KEYWORD_NAME, " +
				"DLP_KEYWORD_INTERNALNAME, DLP_KEYWORD_DESC, DLP_KEYWORD_CONDITION, DLP_KEYWORD_THRESHOLD, " +
				"DLP_KEYWORD_NUMBER, DLP_KEYWORD_BUILTIN, DLP_SUBKEYWORD_LIST) VALUES ('SMEX_PLC_NULL:" + 
				cfgIndex + "', 'SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_KEYWORD_DEFAULT', " + uniPref + "'" + displayName + "', " +
				uniPref + "'" + internalName + "', " + uniPref + "'" + desc + "', '" + condition + "', " + 
				threshold + ", " + number + ", " + builtin + ", " + uniPref + "'" + subKeywordsXml + "')", true))
				break;
			
		}
		var allCfgIndexes = allDefCfgIndexes+allUsrCfgIndexes;
		visitor("UPDATE TM_DLPFilterKeywordMgr SET CFG_DLP_KEYWORD_LIST_CFGSETTING_MV='" + allDefCfgIndexes + 
			"' WHERE CFG_INDEX='SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_KEYWORD_MGR_DEFAULT'", true);
		visitor("UPDATE TM_DLPFilterKeywordMgr SET CFG_DLP_KEYWORD_LIST_CFGSETTING_MV='" + allCfgIndexes + 
		    "' WHERE CFG_INDEX='SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_KEYWORD_MGR'", true);
			
	}

	this.GetDLPExpressionInstallScripts = function(dom, visitor,cn)
	{
	    // backup dlp data to xml file
		if (cn != null)
		{
			// backup expressions
			var dom_temp = new ActiveXObject("MSXML2.DOMDocument");
			dom_temp.loadXML("<dlp><expressions/><expressionMgr/></dlp>");
			var expressionsNode = dom_temp.selectSingleNode("/dlp/expressions");
			
			var sql = "SELECT CFG_INDEX,CFG_DEFAULT_INSTANCE,DLP_EXPRESSION_NAME,DLP_EXPRESSION_INTERNALNAME," +
				"DLP_EXPRESSION_DESC,DLP_EXPRESSION_TYPE,DLP_EXPRESSION_MINLENGTH,DLP_EXPRESSION_MAXLENGTH,"+
				"DLP_EXPRESSION_MINLEFTRADIUS,DLP_EXPRESSION_MAXLEFTRADIUS,DLP_EXPRESSION_MAXRIGHTRADIUS,"+
				"DLP_EXPRESSION_SUFFIXLENGTH,DLP_EXPRESSION_ALPHABETCHARSET,DLP_EXPRESSION_CASESENSITIVE,"+
				"DLP_EXPRESSION_DISPLAYFORMAT,DLP_EXPRESSION_EXAMPLE,DLP_EXPRESSION_VALIDATOR,"+
				"DLP_EXPRESSION_MODIFIED,DLP_EXPRESSION_BUILTIN,DLP_EXPRESSION_PATTERN FROM TM_DLPFilterExpression WHERE " +
				"CFG_INDEX<>'SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_EXPRESSION_DEFAULT'";
			var rs = cn.Execute(sql);
			while (!rs.EOF)
			{
				var expression = dom_temp.createElement("expression");
				expression.setAttribute("cfg_index", rs(0).Value);
				expression.setAttribute("def_instance", rs(1).Value);
				expression.setAttribute("name", rs(2).Value);
				expression.setAttribute("internalname", rs(3).Value);
				expression.setAttribute("description", rs(4).Value);
				expression.setAttribute("type", rs(5).Value);
				expression.setAttribute("minlength", rs(6).Value);
				expression.setAttribute("maxlength", rs(7).Value);
				expression.setAttribute("minleftradius", rs(8).Value);
				expression.setAttribute("maxleftradius", rs(9).Value);
				expression.setAttribute("maxrightradius", rs(10).Value);
				expression.setAttribute("suffixlength", rs(11).Value);
				expression.setAttribute("alphcharset", rs(12).Value);
				expression.setAttribute("casesensitive", rs(13).Value);
				expression.setAttribute("displayformat", rs(14).Value);
				expression.setAttribute("examp", rs(15).Value);
				expression.setAttribute("validator", rs(16).Value);
				expression.setAttribute("modify", rs(17).Value);
				expression.setAttribute("builtin", rs(18).Value);
				expression.text = rs(19).Value;
				expressionsNode.appendChild(expression);
				
				rs.MoveNext();
			}
			rs.Close();
			
			// backup mgr table
			var mgrNode = dom_temp.selectSingleNode("/dlp/expressionMgr");
			sql = "SELECT CFG_INDEX,CFG_DLP_EXPRESSION_LIST_CFGSETTING_MV FROM TM_DLPFilterExpressionMgr";
			rs = cn.Execute(sql);
			while (!rs.EOF)
			{
				var mgr = dom_temp.createElement("mgr");
				mgr.setAttribute("cfg_index", rs(0).Value);
				mgr.text = rs(1).Value;
				mgrNode.appendChild(mgr);
				
				rs.MoveNext();
			}
			rs.Close();
			
			dom_temp.save(sWorkingDirectory + "\\" + DLPExpressBackupXml);
		}
		// delete built-in expressions
		var sql = "DELETE FROM TM_DLPFilterExpression WHERE DLP_EXPRESSION_BUILTIN=" + ((this.Type == "SQLSVR") ? "1" : "True");
		visitor(sql, true);
		
		var allUsrCfgIndexes = "";
		var allDefCfgIndexes = "";
		//get customize expression index	
		if (cn != null)
		{
			var indexPrefix = "SMEX_PLC_NULL:";
			var rs = cn.Execute("SELECT CFG_INDEX FROM TM_DLPFilterExpression where CFG_INDEX!='SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_EXPRESSION_DEFAULT'");
	        
	        while (!rs.EOF)
	        {
	        	var cfgIndex = rs(0).Value;
	            allUsrCfgIndexes += "TM_DLPFilterExpression:" + cfgIndex.substr(indexPrefix.length) + ":";  
		        rs.MoveNext();
	        }
			rs.Close();
		}
		
		var exps = dom.selectNodes("/SAPolicy/digitalAssets/entity");
		var uniPref = (this.Type == "SQLSVR") ? "N" : "";
		
		for (var i=0; i<exps.length; ++i)
		{
			var internalName = exps[i].attributes.getNamedItem("name").text;
			var cfgIndex = "SMEX_SUB_CFG_DLP_EXPRESSION" + internalName;
			var displayName = exps[i].attributes.getNamedItem("display_name").text.replace(/'/g, "''");
			var desc = exps[i].attributes.getNamedItem("description").text.replace(/'/g, "''");
			var type = exps[i].attributes.getNamedItem("type").text;
			var minLenNode = exps[i].attributes.getNamedItem("minLength");
			var minLen = minLenNode == null ? 0 : minLenNode.text;
			var maxLenNode = exps[i].attributes.getNamedItem("maxLength");
			var maxLen = maxLenNode == null ? 0 : maxLenNode.text;
			var minLeftRadiusNode = exps[i].attributes.getNamedItem("minLeftRadius");
			var minLeftRadius = minLeftRadiusNode == null ? 0 : minLeftRadiusNode.text;
			var maxLeftRadiusNode = exps[i].attributes.getNamedItem("maxLeftRadius");
			var maxLeftRadius = maxLeftRadiusNode == null ? 0 : maxLeftRadiusNode.text;
			var maxRightRadiusNode = exps[i].attributes.getNamedItem("maxRightRadius");
			var maxRightRadius = maxRightRadiusNode == null ? 0 : maxRightRadiusNode.text;
			var suffixLengthNode = exps[i].attributes.getNamedItem("suffixLength");
			var suffixLength = suffixLengthNode == null ? 0 : suffixLengthNode.text;
			var exp = exps[i].selectSingleNode("./regularExpression").text.replace(/'/g, "''");
			var alphaCharsetNode = exps[i].selectSingleNode("./alphabetCharset");
			var alphaCharset = alphaCharsetNode == null ? "" : alphaCharsetNode.text.replace(/'/g, "''");
			var caseSens = exps[i].attributes.getNamedItem("caseSensitive").text;
			if (this.Type == "SQLSVR")
				caseSens = (caseSens == "true") ? 1 : 0;
			else
				caseSens = (caseSens == "true") ? "True" : "False";
			var dispFormat = exps[i].selectSingleNode("./patternForDisplay").text.replace(/'/g, "''");
			var example = exps[i].selectSingleNode("./examples").text.replace(/'/g, "''");
			var vldr = exps[i].attributes.getNamedItem("validator").text.replace(/'/g, "''");
			var builtin = exps[i].attributes.getNamedItem("pre-defined").text;
			if (this.Type == "SQLSVR")
				builtin = (builtin == "true") ? 1 : 0;
			else
				builtin = (builtin == "true") ? "True" : "False";
			
			if (!visitor("INSERT INTO TM_DLPFilterExpression (CFG_INDEX, CFG_DEFAULT_INSTANCE, DLP_EXPRESSION_NAME, " +
				"DLP_EXPRESSION_INTERNALNAME, DLP_EXPRESSION_DESC, DLP_EXPRESSION_TYPE, DLP_EXPRESSION_MINLENGTH, " +
				"DLP_EXPRESSION_MAXLENGTH, DLP_EXPRESSION_MINLEFTRADIUS, DLP_EXPRESSION_MAXLEFTRADIUS, " +
				"DLP_EXPRESSION_MAXRIGHTRADIUS, DLP_EXPRESSION_SUFFIXLENGTH, DLP_EXPRESSION_PATTERN, " +
				"DLP_EXPRESSION_ALPHABETCHARSET, DLP_EXPRESSION_CASESENSITIVE, DLP_EXPRESSION_DISPLAYFORMAT, " +
				"DLP_EXPRESSION_EXAMPLE, DLP_EXPRESSION_VALIDATOR, DLP_EXPRESSION_BUILTIN) VALUES ('SMEX_PLC_NULL:" + cfgIndex + 
				"', 'SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_EXPRESSION_DEFAULT', " + uniPref + "'" + displayName + "', '" +
				internalName + "', " + uniPref + "'" + desc + "', '" + type + "', " + minLen + ", " + maxLen + ", " + 
				minLeftRadius + ", " + maxLeftRadius + ", " + maxRightRadius + ", " + suffixLength + ", " + uniPref + 
				"'" + exp + "', '" + alphaCharset + "', " + caseSens + ", '" + dispFormat + "', '" + example + "', '" +
				vldr + "', " + builtin + ")", true))
				break;
			
			allDefCfgIndexes += "TM_DLPFilterExpression:" + cfgIndex + ":";
		}
		
		var allCfgIndexes = allDefCfgIndexes+allUsrCfgIndexes;
		visitor("UPDATE TM_DLPFilterExpressionMgr SET CFG_DLP_EXPRESSION_LIST_CFGSETTING_MV='" + allDefCfgIndexes + 
			"' WHERE CFG_INDEX='SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_EXPRESSION_MGR_DEFAULT'", true);
		visitor("UPDATE TM_DLPFilterExpressionMgr SET CFG_DLP_EXPRESSION_LIST_CFGSETTING_MV='" + allCfgIndexes + 
		    "' WHERE CFG_INDEX='SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_EXPRESSION_MGR'", true);
	}
	
	this.GetDLPTemplateInstallScripts = function(dom, visitor, cn)
	{
		WScript.Echo("Enter GetDLPTemplateInstallScripts");
		
		var uniPref = (this.Type == "SQLSVR") ? "N" : "";
		
		// backup dlp data to xml file
		if (cn != null)
		{
			// backup templates
			var dom_temp = new ActiveXObject("MSXML2.DOMDocument");
			dom_temp.loadXML("<dlp><templates/><templateMgr/></dlp>");
			var templatesNode = dom_temp.selectSingleNode("/dlp/templates");
			
			var sql = "SELECT CFG_INDEX,CFG_DEFAULT_INSTANCE,DLP_TEMPLATE_NAME,DLP_TEMPLATE_DESC," +
				"DLP_TEMPLATE_BUILTIN,DLP_TEMPLATE_ELEMENT FROM TM_DLPFilterTemplate WHERE " +
				"CFG_INDEX<>'SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_TEMPLATE_DEFAULT'";
			var rs = cn.Execute(sql);
			while (!rs.EOF)
			{
				var tmpl = dom_temp.createElement("template");
				tmpl.setAttribute("cfg_index", rs(0).Value);
				tmpl.setAttribute("def_instance", rs(1).Value);
				tmpl.setAttribute("name", rs(2).Value);
				tmpl.setAttribute("description", rs(3).Value);
				tmpl.setAttribute("builtin", rs(4).Value);
				tmpl.text = rs(5).Value;
				templatesNode.appendChild(tmpl);
				
				rs.MoveNext();
			}
			rs.Close();
			
			// backup mgr table
			var mgrNode = dom_temp.selectSingleNode("/dlp/templateMgr");
			sql = "SELECT CFG_INDEX,CFG_DLP_TEMPLATE_LIST_CFGSETTING_MV FROM TM_DLPFilterTemplateMgr";
			rs = cn.Execute(sql);
			while (!rs.EOF)
			{
				var mgr = dom_temp.createElement("mgr");
				mgr.setAttribute("cfg_index", rs(0).Value);
				mgr.text = rs(1).Value;
				mgrNode.appendChild(mgr);
				
				rs.MoveNext();
			}
			rs.Close();
			
			dom_temp.save(sWorkingDirectory + "\\" + DLPBackupXml);
		}
		
		// delete built-in templates
		var sql = "DELETE FROM TM_DLPFilterTemplate WHERE DLP_TEMPLATE_BUILTIN=" + ((this.Type == "SQLSVR") ? "1" : "True");
		visitor(sql, true);
		
		var allUsrCfgIndexes = "";
		var allDefCfgIndexes = "";
		var arrSql = new Array();
		
		if (cn != null)
		{
			var indexPrefix = "SMEX_PLC_NULL:";
			
			// and record customize cfg_index
			var rs = cn.Execute("SELECT CFG_INDEX FROM TM_DLPFilterTemplate where CFG_INDEX!='SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_TEMPLATE_DEFAULT'");
	        
	        while (!rs.EOF)
	        {
	        	var cfgIndex = rs(0).Value;	
	        	allUsrCfgIndexes += "TM_DLPFilterTemplate:" + cfgIndex.substr(indexPrefix.length) + ":"; 
		        rs.MoveNext();
	        }
			rs.Close();
		}
		
		// insert new built-in templates from xml
		var tmpls = dom.selectNodes("/SAPolicy/complianceTemplates/template");
		for (var i=0; i<tmpls.length; ++i)
		{
			var internalName = tmpls[i].attributes.getNamedItem("name").text;
            if (internalName == "00000000-0000-0000-0004-000000000219")
				continue;
			var cfgIndex = "SMEX_SUB_CFG_DLP_TEMPLATE" + internalName;
			var displayName = tmpls[i].attributes.getNamedItem("display_name").text.replace(/'/g, "''");
			var builtin = tmpls[i].attributes.getNamedItem("pre-defined").text;
			if (this.Type == "SQLSVR")
				builtin = (builtin == "true") ? 1 : 0;
			else
				builtin = (builtin == "true") ? "True" : "False";
			var desc = tmpls[i].attributes.getNamedItem("description").text.replace(/'/g, "''");
			var content = tmpls[i].xml.replace(/'/g, "''");
			
			var industry = "";
			var collIndustry = dom.selectNodes("/SAPolicy/industries/industry[.//template_id='" + internalName + "']/@name");
			for (var j=0; j<collIndustry.length; ++j) 
			{ 
				industry += collIndustry[j].text.replace(/'/g, "''")+";"; 
			}
			
			var region = "";
			var collRegion = dom.selectNodes("/SAPolicy/regions/region[.//template_id='" + internalName+ "']/@name");
			for (var k=0; k<collRegion.length; ++k) 
			{ 
				region += collRegion[k].text.replace(/'/g, "''")+";"; 
			}
			
			if (!visitor("INSERT INTO TM_DLPFilterTemplate (CFG_INDEX, DLP_TEMPLATE_NAME, DLP_TEMPLATE_BUILTIN, " +
				"DLP_TEMPLATE_DESC, DLP_TEMPLATE_ELEMENT, DLP_TEMPLATE_INDUSTRY, DLP_TEMPLATE_REGION) VALUES ('SMEX_PLC_NULL:" + 
				cfgIndex + "', " + uniPref + "'" + displayName + "', " + builtin + ", " + uniPref + "'" + desc + "', '" + 
				content + "', '"+ industry + "', '"+ region + "')", true))
				return;
			
			allDefCfgIndexes += "TM_DLPFilterTemplate:" + cfgIndex + ":";
		}
		
		visitor("UPDATE TM_DLPFilterTemplateMgr SET CFG_DLP_TEMPLATE_LIST_CFGSETTING_MV='" + allDefCfgIndexes + 
			"' WHERE CFG_INDEX='SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_TEMPLATE_MGR_DEFAULT'", true);
		visitor("UPDATE TM_DLPFilterTemplateMgr SET CFG_DLP_TEMPLATE_LIST_CFGSETTING_MV='" + allDefCfgIndexes + 
			allUsrCfgIndexes + "' WHERE CFG_INDEX='SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_TEMPLATE_MGR'", true);
		
		WScript.Echo("Leave GetDLPTemplateInstallScripts");
	}
	
	this.RollbackDLPChanges = function(visitor, cn)
	{
		WScript.Echo("Enter RollbackDLPChanges");
		if (this.Name.substr(0, 4) != "Conf")
        {
        	WScript.Echo("Not config db, skip rollback dlp data");
        	return;
        }
		
		var uniPref = (this.Type == "SQLSVR") ? "N" : "";
		
		// delete templates
		visitor("DELETE FROM TM_DLPFilterTemplate WHERE CFG_INDEX<>'SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_TEMPLATE_DEFAULT'", true);
		
		var arrSql = new Array();
		
		// recover data from backup xml file,
		var sTemplateIdList = "";
		var dom = new ActiveXObject("MSXML2.DOMDocument");
		if (dom.load(sWorkingDirectory + "\\" + DLPBackupXml))
		{
			// restore template
			var coll = dom.selectNodes("dlp/templates/template");
			var idxPrefix = "SMEX_PLC_NULL:";
			for (var i=0; i<coll.length; ++i)
			{
				var cfgIndex = coll[i].getAttribute("cfg_index");
				var defInstance = coll[i].getAttribute("def_instance");
				var displayName = coll[i].getAttribute("name").replace(/'/g, "''");
				var desc = coll[i].getAttribute("description").replace(/'/g, "''");
				var builtin = coll[i].getAttribute("builtin");
				var content = coll[i].text.replace(/'/g, "''");
				
				if (!visitor("INSERT INTO TM_DLPFilterTemplate (CFG_INDEX,CFG_DEFAULT_INSTANCE," +
					"DLP_TEMPLATE_NAME,DLP_TEMPLATE_BUILTIN,DLP_TEMPLATE_DESC,DLP_TEMPLATE_ELEMENT) VALUES ('" + 
					cfgIndex + "', '" + defInstance + "'," + uniPref + "'" + displayName + "', " + builtin + ", " + 
					uniPref + "'" + desc + "', '" + content + "')", true))
					return;
				
				sTemplateIdList += cfgIndex.substr(idxPrefix.length) + ",";
			}
			
			// restore mgr
			coll = dom.selectNodes("dlp/templateMgr/mgr");
			for (i=0; i<coll.length; ++i)
			{
				var cfgIndex = coll[i].getAttribute("cfg_index");
				var content = coll[i].text;
				
				if (!visitor("UPDATE TM_DLPFilterTemplateMgr SET CFG_DLP_TEMPLATE_LIST_CFGSETTING_MV='" +
					content + "' WHERE CFG_INDEX='" + cfgIndex + "'", true))
					return;
			}
		}
		dom = null;
		
		WScript.Echo("Leave RollbackDLPChanges");
	}
	
	this.RollbackDLPKeywordChanges = function(visitor, cn)
	{
		WScript.Echo("Enter RollbackDLPKeywordChanges");
		if (this.Name.substr(0, 4) != "Conf")
        {
        	WScript.Echo("Not config db, skip rollback dlp data");
        	return;
        }
		
		var uniPref = (this.Type == "SQLSVR") ? "N" : "";
		
		// delete keywords
		visitor("DELETE FROM TM_DLPFilterKeyword WHERE CFG_INDEX<>'SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_KEYWORD_DEFAULT'", true);
		
		var arrSql = new Array();
		
		// recover data from backup xml file,
		var skeywordIdList = "";
		var dom = new ActiveXObject("MSXML2.DOMDocument");
		if (dom.load(sWorkingDirectory + "\\" + DLPKeywordBackupXml))
		{
			// restore keyword
			var coll = dom.selectNodes("dlp/keywords/keyword");
			var idxPrefix = "SMEX_PLC_NULL:";
			for (var i=0; i<coll.length; ++i)
			{
				var cfgIndex = coll[i].getAttribute("cfg_index");
				var defInstance = coll[i].getAttribute("def_instance");
				var displayName = coll[i].getAttribute("name").replace(/'/g, "''");
				var internalName = coll[i].getAttribute("internalname");
				var desc = coll[i].getAttribute("description").replace(/'/g, "''");
				var condition = coll[i].getAttribute("condition");
				var threshold = coll[i].getAttribute("threshold");
				var number = coll[i].getAttribute("number");
				var modify = coll[i].getAttribute("modify");
				var builtin = coll[i].getAttribute("builtin");
				var keywordcontent = coll[i].text.replace(/'/g, "''");
				
				if (!visitor("INSERT INTO TM_DLPFilterKeyword (CFG_INDEX,CFG_DEFAULT_INSTANCE," +
					"DLP_KEYWORD_NAME,DLP_KEYWORD_INTERNALNAME,DLP_KEYWORD_DESC,DLP_KEYWORD_CONDITION,"+
					"DLP_KEYWORD_THRESHOLD,DLP_KEYWORD_NUMBER,DLP_KEYWORD_MODIFIED,DLP_KEYWORD_BUILTIN,DLP_SUBKEYWORD_LIST) VALUES ('" + 
					cfgIndex + "', '" + defInstance + "'," + uniPref + "'" + displayName + "', '" + internalName + "', " + 
					uniPref + "'" + desc + "', '" + condition + "',"+threshold+","+number+","+modify+","+builtin+","+uniPref + "'" + keywordcontent+ "')", true))
					return;
				
				skeywordIdList += cfgIndex.substr(idxPrefix.length) + ",";
			}
			
			// restore mgr
			coll = dom.selectNodes("dlp/keywordMgr/mgr");
			for (i=0; i<coll.length; ++i)
			{
				var cfgIndex = coll[i].getAttribute("cfg_index");
				var content = coll[i].text;
				
				if (!visitor("UPDATE TM_DLPFilterKeywordMgr SET CFG_DLP_KEYWORD_LIST_CFGSETTING_MV='" +
					content + "' WHERE CFG_INDEX='" + cfgIndex + "'", true))
					return;
			}
		}
		dom = null;
		
		WScript.Echo("Leave RollbackDLPKeywordChanges");
	}
	
	this.RollbackDLPExpressionChanges = function(visitor, cn)
	{
		WScript.Echo("Enter RollbackDLPExpressionChanges");
		if (this.Name.substr(0, 4) != "Conf")
        {
        	WScript.Echo("Not config db, skip rollback dlp data");
        	return;
        }
		
		var uniPref = (this.Type == "SQLSVR") ? "N" : "";
		
		// delete expressions
		visitor("DELETE FROM TM_DLPFilterExpression WHERE CFG_INDEX<>'SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_EXPRESSION_DEFAULT'", true);

		var arrSql = new Array();
		
		// recover data from backup xml file,
		var sExpressionIdList = "";
		var dom = new ActiveXObject("MSXML2.DOMDocument");
		if (dom.load(sWorkingDirectory + "\\" + DLPExpressBackupXml))
		{
			// restore expression
			var coll = dom.selectNodes("dlp/expressions/expression");
			var idxPrefix = "SMEX_PLC_NULL:";
			for (var i=0; i<coll.length; ++i)
			{
				var cfgIndex = coll[i].getAttribute("cfg_index");
				//var defInstance = coll[i].getAttribute("def_instance");
				var displayName = coll[i].getAttribute("name").replace(/'/g, "''");
				var innerName = coll[i].getAttribute("internalname");
				var desc = coll[i].getAttribute("description").replace(/'/g, "''");
				var type = coll[i].getAttribute("type");
				var minLen = coll[i].getAttribute("minlength");
				var maxLen = coll[i].getAttribute("maxlength");
				var minLeftRadius = coll[i].getAttribute("minleftradius");
				var maxLeftRadius = coll[i].getAttribute("maxleftradius");
				var maxRightRadius = coll[i].getAttribute("maxrightradius");
				var suffixLength = coll[i].getAttribute("suffixlength");
				var alph = coll[i].getAttribute("alphcharset");
				var casesenitive = coll[i].getAttribute("casesensitive");
				var dispFormat = coll[i].getAttribute("displayformat");
				var example = coll[i].getAttribute("examp");
				var validator = coll[i].getAttribute("validator");
				var modify = coll[i].getAttribute("modify");
				var builtin = coll[i].getAttribute("builtin");
				var pattern = coll[i].text.replace(/'/g, "''");
				
				if (!visitor("INSERT INTO TM_DLPFilterExpression (CFG_INDEX, CFG_DEFAULT_INSTANCE, DLP_EXPRESSION_NAME, " +
				"DLP_EXPRESSION_INTERNALNAME, DLP_EXPRESSION_DESC, DLP_EXPRESSION_TYPE, DLP_EXPRESSION_MINLENGTH, " +
				"DLP_EXPRESSION_MAXLENGTH, DLP_EXPRESSION_MINLEFTRADIUS, DLP_EXPRESSION_MAXLEFTRADIUS, " +
				"DLP_EXPRESSION_MAXRIGHTRADIUS, DLP_EXPRESSION_SUFFIXLENGTH, DLP_EXPRESSION_PATTERN, " +
				"DLP_EXPRESSION_ALPHABETCHARSET, DLP_EXPRESSION_CASESENSITIVE, DLP_EXPRESSION_DISPLAYFORMAT, " +
				"DLP_EXPRESSION_EXAMPLE, DLP_EXPRESSION_VALIDATOR, DLP_EXPRESSION_MODIFIED,DLP_EXPRESSION_BUILTIN) VALUES ('" + cfgIndex + 
				"', 'SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_EXPRESSION_DEFAULT', " + uniPref + "'" + displayName + "', '" +
				innerName + "', " + uniPref + "'" + desc + "', '" + type + "', " + minLen + ", " + maxLen + ", " + 
				minLeftRadius + ", " + maxLeftRadius + ", " + maxRightRadius + ", " + suffixLength + ", " + uniPref + 
				"'" + pattern + "', '" + alph + "', " + casesenitive + ", '" + dispFormat + "', '" + example + "', '" +
				validator + "', " + modify+","+builtin + ")", true))
				break;
				
				sExpressionIdList += cfgIndex.substr(idxPrefix.length) + ",";
			}
			
			// restore mgr
			coll = dom.selectNodes("dlp/expressionMgr/mgr");
			for (i=0; i<coll.length; ++i)
			{
				var cfgIndex = coll[i].getAttribute("cfg_index");
				var content = coll[i].text;
				if (!visitor("UPDATE TM_DLPFilterExpressionMgr SET CFG_DLP_EXPRESSION_LIST_CFGSETTING_MV='" +
					content + "' WHERE CFG_INDEX='" + cfgIndex + "'", true))
					return;
			}
		}
		dom = null;
		
		WScript.Echo("Leave RollbackDLPExpressionChanges");
	}
	
	this.UpdateDLPPolicy = function(visitor, cn)
	{
		WScript.Echo("Enter UpdateDLPPolicy");
		if (this.Name.substr(0, 4) != "Conf")
        {
        	WScript.Echo("Not config db, skip rollback dlp data");
        	return;
        }
		
		var uniPref = (this.Type == "SQLSVR") ? "N" : "";
		var sql = "SELECT CFG_DLP_TEMPLATE_LIST_CFGSETTING_MV FROM TM_DLPFilterTemplateMgr " +
		           "WHERE CFG_INDEX = 'SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_TEMPLATE_MGR'";				   
		var rsTemplateList = cn.Execute(sql);
		var lstTemplateList ="";
        while (!rsTemplateList.EOF)
		{
			lstTemplateList =  rsTemplateList(0).Value;
			break;
		}
		rsTemplateList.Close();
		if(lstTemplateList == "")
		{
		    WScript.Echo("Error: Template list is empty in the TM_DLPFilterTemplateMgr table.");
			return;
		}
		sql = "SELECT CFG_INDEX,DLP_TEMPLATE_LIST FROM TM_DLPFilterRule WHERE " +
			"CFG_INDEX not like 'SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_RULE%_DEFAULT'";
        var arrPolicy = new Array();		
		var rs = cn.Execute(sql);
		while (!rs.EOF)
		{
			var index = rs(0).Value;
			var templateList =  rs(1).Value;
			var strUpdateValue = templateList;
			var iLastCharIndex = templateList.length -1;
			if(templateList.charAt(iLastCharIndex) ==",")
			  templateList = templateList.substr(0,templateList.length -1); //remove the last ','
			  
			var templateArray = templateList.split(",");
			var iLength = templateArray.length;
			var bUpdate = false;
			for(var i = 0;i<iLength;i++)
			{
			  var strTemplateID = templateArray[i];
			  if(-1 == lstTemplateList.indexOf(strTemplateID))
			  {
				  var strReplace = strTemplateID+",";
				  strUpdateValue = strUpdateValue.replace(strReplace,"");  
				  bUpdate = true;
			  }
			}
			if(bUpdate)
			{
			    arrPolicy.push(new PolicyMap(index,strUpdateValue));
			}
			rs.MoveNext();
		}
		rs.Close();
		var iPolicyLeng = arrPolicy.length;
		for(var j = 0;j<iPolicyLeng;j++)
		{
		   var ID = arrPolicy[j].PolicyId;
		   var strValue = arrPolicy[j].newValue;
		   visitor("UPDATE TM_DLPFilterRule SET DLP_TEMPLATE_LIST='" + strValue + 
				"' WHERE CFG_INDEX='"+ID+"'", true);
		}
		WScript.Echo("Leave UpdateDLPPolicy");
	}
	
	this.UpdateDLPPolicyAccount = function(visitor, cn)
	{
	    WScript.Echo("Enter UpdateDLPPolicyAccount");
		if (this.Name.substr(0, 4) != "Conf")
        {
        	WScript.Echo("Not config db, skip rollback DLP Policy.");
        	return;
        }
		
		var sql = "SELECT DLP_RULE_SETTING_LIST_CFGSETTING_MV FROM TM_DLPFilter " +
		           "WHERE CFG_INDEX = 'SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_RS'";				   
		var rsRuleList = cn.Execute(sql);
		var strRuleList ="";
        while (!rsRuleList.EOF)
		{
			strRuleList =  rsRuleList(0).Value;
			break;
		}
		rsRuleList.Close();
		var strUpdateRuleList = strRuleList;
		var arrDelPolicy = new Array();
		if(strRuleList != "")
		{
			var iLastCharIndex = strRuleList.length -1;
			if(strRuleList.charAt(iLastCharIndex) ==":")
			  strRuleList = strRuleList.substr(0,iLastCharIndex); //remove the last ':'
			var arrRuleList = strRuleList.split(":");
			//format: DLP_FILTER:ID
			if(arrRuleList.length%2 == 0)
            {
			    var iLength = arrRuleList.length;
			    for(var i = 1;i<iLength;)
			    {
				   var Ruleindex ="SMEX_PLC_NULL:"+ arrRuleList[i];
			       sql = "SELECT DLP_RECIPIENT_SET, DLP_RECIPIENT_EXCEPTION_SET FROM TM_DLPFilterRule " +
		           "WHERE CFG_INDEX = '"+Ruleindex+"'";
                   var rsRule = cn.Execute(sql);
                   while(!rsRule.EOF)
                   {  
				       var recipient = rsRule(0).Value;
				       var recipientExcp = rsRule(1).Value;
					   if(recipient!="" ||recipientExcp!="")
					   {
					       arrDelPolicy.push(arrRuleList[i]);
						   var strID = arrRuleList[i-1]+":"+arrRuleList[i]+":";
						   strUpdateRuleList = strUpdateRuleList.replace(strID,"");  
					   }
					   break;
                   }
				   rsRule.Close();
                   i= i+2;				   
			    }
            }
            else
            {
			   WScript.Echo("Wrong format of DLP policies.");
            }			
		}
		else
		{
		    WScript.Echo("DLP real-time policies is empty.");
		}
		
        var iDelLength = arrDelPolicy.length;
		if(iDelLength!=0)
		{
		   for(var j = 0;j<iDelLength;j++)
		   {
		      var index ="SMEX_PLC_NULL:"+ arrDelPolicy[j];
			  visitor("DELETE FROM TM_DLPFilterRule WHERE CFG_INDEX ='" + index + 
				"'" , true);
		   }
		   visitor("UPDATE TM_DLPFilter SET DLP_RULE_SETTING_LIST_CFGSETTING_MV='" + strUpdateRuleList + 
				"' WHERE CFG_INDEX='SMEX_PLC_NULL:SMEX_SUB_CFG_DLP_RS'", true);
		}
		
		WScript.Echo("Leave UpdateDLPPolicyAccount");
	}
	
	this.UpdateABPolicyAccount = function(visitor, cn)
	{
	    WScript.Echo("Enter UpdateABPolicyAccount");
		if (this.Name.substr(0, 4) != "Conf")
        {
        	WScript.Echo("Not config db, skip rollback AB exception.");
        	return;
        }
		
		var sql = "SELECT CFG_EXPRULE_SETTING_LIST_CFGSETTING_MV FROM TM_FileBlockingException " +
		           "WHERE CFG_INDEX = 'SMEX_PLC_NULL:SMEX_SUB_CFG_FB_EXCEPTION_INST'";				   
		var rsRuleList = cn.Execute(sql);
		var strRuleList ="";
        while (!rsRuleList.EOF)
		{
			strRuleList =  rsRuleList(0).Value;
			break;
		}
		rsRuleList.Close();
		var strUpdateRuleList = strRuleList;
		var arrDelPolicy = new Array();
		if(strRuleList != "")
		{
			var iLastCharIndex = strRuleList.length -1;
			if(strRuleList.charAt(iLastCharIndex) ==":")
			  strRuleList = strRuleList.substr(0,iLastCharIndex); //remove the last ':'
			var arrRuleList = strRuleList.split(":");
			//format: AB_FILTER:ID
			if(arrRuleList.length%2 == 0)
            {
			    var iLength = arrRuleList.length;
			    for(var i = 1;i<iLength;)
			    {
				   var Ruleindex ="SMEX_PLC_NULL:"+ arrRuleList[i];
			       sql = "SELECT FB_SENDER_SET, FB_SENDER_EXCEPTION_SET FROM TM_FileBlocking " +
		           "WHERE CFG_INDEX = '"+Ruleindex+"'";
                   var rsRule = cn.Execute(sql);
                   while(!rsRule.EOF)
                   {  
				       var sender = rsRule(0).Value;
				       var senderExcp = rsRule(1).Value;
					   if(sender!="" ||senderExcp!="")
					   {
					       arrDelPolicy.push(arrRuleList[i]);
						   var strID = arrRuleList[i-1]+":"+arrRuleList[i]+":";
						   strUpdateRuleList = strUpdateRuleList.replace(strID,"");  
					   }
					   break;
                   }
				   rsRule.Close();
                   i= i+2;				   
			    }
            }
            else
            {
			   WScript.Echo("Wrong format of AB Exception.");
            }			
		}
		else
		{
		    WScript.Echo("AB Exception is empty.");
		}
		
        var iDelLength = arrDelPolicy.length;
		if(iDelLength!=0)
		{
		   for(var j = 0;j<iDelLength;j++)
		   {
		      var index ="SMEX_PLC_NULL:"+ arrDelPolicy[j];
			  visitor("DELETE FROM TM_FileBlocking WHERE CFG_INDEX ='" + index + 
				"'" , true);
		   }
		   visitor("UPDATE TM_FileBlockingException SET CFG_EXPRULE_SETTING_LIST_CFGSETTING_MV='" + strUpdateRuleList + 
				"' WHERE CFG_INDEX='SMEX_PLC_NULL:SMEX_SUB_CFG_FB_EXCEPTION_INST'", true);
		}
		
		WScript.Echo("Leave UpdateABPolicyAccount");
	}
	
	this.UpdateScheduleReport = function(visitor, cn)
	{
		WScript.Echo("Enter UpdateScheduleReport");
		if (this.Name.substr(0, 4) != "Conf")
        {
        	WScript.Echo("Not config db, skip rollback schedule report.");
        	return;
        }
		
		var uniPref = (this.Type == "SQLSVR") ? "N" : "";
		var sql = "SELECT CFG_INDEX, RPT_TEMPLATE_CONTENT FROM TM_ReportTemplate " +
		           "WHERE CFG_INDEX <> 'SMEX_PLC_NULL:SMEX_SUB_CFG_REPORT_TEMPLATE'";				   
        var arrReport = new Array();		
		var rs = cn.Execute(sql);
		while (!rs.EOF)
		{
			var index = rs(0).Value;
			var reportContent =  rs(1).Value;
			var strUpdateValue = reportContent;
			var bUpdate = false;
			var iPosLeft = reportContent.indexOf("<server_list>");
			var iPosRight = reportContent.indexOf("</server_list>");
	        if(iPosLeft!=-1 && iPosRight!=-1)
			{
			    var strReplace = reportContent.substring(iPosLeft,iPosRight+14);
				strUpdateValue = strUpdateValue.replace(strReplace,"");
				WScript.Echo("Original server list:"+strReplace);
				bUpdate = true;
			}
			if(bUpdate)
			{
			    arrReport.push(new PolicyMap(index,strUpdateValue));
			}
			rs.MoveNext();
		}
		rs.Close();
		var iReportLeng = arrReport.length;
		for(var j = 0;j<iReportLeng;j++)
		{
		   var ID = arrReport[j].PolicyId;
		   var strValue = arrReport[j].newValue;
		   visitor("UPDATE TM_ReportTemplate SET RPT_TEMPLATE_CONTENT='" + strValue + 
				"' WHERE CFG_INDEX='"+ID+"'", true);
		}
		WScript.Echo("Leave UpdateScheduleReport");
	}
	
	this.GetDigitalAssetMap = function()
	{
		var arrMap = new Array();
		var daMapFile = sWorkingDirectory + "\\cfg_dlp_da_map.txt";
		var fso = new ActiveXObject("Scripting.FileSystemObject");
		var f = fso.OpenTextFile(daMapFile, 1, false);
		while (!f.AtEndOfStream)
		{
			var s = f.ReadLine();
			if (s.length > 0)
			{
				if (s.charAt(0) != "#")
				{
					var tabIndex = s.indexOf("\t");
					if (tabIndex > 0)
					{
						var left = s.substring(0, tabIndex);
						var right = s.substr(tabIndex+1);
						arrMap.push(new IDMap(trim(left), trim(right)));
					}
				}
			}
		}
		f.Close();
		
		return arrMap;
	}
	
	this.GetDLPTemplateIdMap = function()
	{
		var arr = [
			new IDMap("F084907F-B35F-41ff-BD8E-DD174C69A5EE", "00000000-0000-0000-0004-000000000001"), //"glba"
			new IDMap("FE5D56B7-C127-4e1c-99F5-169622459EF9", "00000000-0000-0000-0004-000000000002"), //"hipaa"
			new IDMap("27EABD79-6D9D-440b-8681-5AB21B486645", "00000000-0000-0000-0004-000000000003"), //"pcidss"
			new IDMap("495F6370-8F6B-4ff2-9D18-6EF2DF8FD67E", "00000000-0000-0000-0004-000000000004"), //"sb1386"
			new IDMap("210566AE-D693-4f81-8416-EFF2A48FDA8C", "00000000-0000-0000-0004-000000000005"), //"uspii"
			new IDMap("E155E535-EF13-4dad-99F3-ED9E22CAEF9C", "00000000-0000-0000-0004-000000000048"), //"source_code"
			
			new IDMap("16F4538D-9CD8-43bf-8DCF-3D485EB56D52", "00000000-0000-0000-0004-000000000100"), //"jp_pi_100"
			new IDMap("525B0E99-C090-4496-B67E-62C93107EB2A", "00000000-0000-0000-0004-000000000099"), //"jp_pi_10"
			new IDMap("18FF6835-4EED-4c38-AB9B-835F86135FC0", "00000000-0000-0000-0004-000000000101"), //"jp_pi_50"
			new IDMap("D6CF7EBA-FE92-44f7-AB9A-7BC6908A7FAD", "00000000-0000-0000-0004-000000000097"), //"jp_pi_obk50"
			new IDMap("E58DBD06-99FD-4219-BF57-06C4F6EDD6BF", "00000000-0000-0000-0004-000000000098"), //"jp_pi_h50"
			new IDMap("B9DEA4EF-1C9F-4a6b-A222-395CAB45173B", "00000000-0000-0000-0004-000000000102") //"jp_pi_k50"
		];
		return arr;
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////////
    this.GetUpgradeScripts = function (visitor, cn)
    {
    	WScript.Echo("Enter GetUpgradeScripts");
        
        this.ImportDLPData(visitor, cn);
        
		WScript.Echo("*************************************************************");
		WScript.Echo("end execute the sql commands");
				WScript.Echo("Leave GetUpgradeScripts");
        
    }
     ///////////////////////////////////////////////////////////////////////////////////////////////
    this.GetRollbackScripts = function (visitor, cn)
    {
    	WScript.Echo("Enter GetRollbackScripts");
		this.UpdateDLPPolicyAccount(visitor, cn);
		this.UpdateABPolicyAccount(visitor, cn);
        var fSqlSatementCreation     = sWorkingDirectory + "\\" + "dbTableCreationSql4SP1.xslt";
        var xDatabaseInstallSql      = XDoc();
        var xDatabaseSchemaTransform = XDoc();
        xDatabaseSchemaTransform.load(fSqlSatementCreation);
        WScript.Echo("after xDatabaseSchemaTransform.load");
        var xNodeInstall = xProfile.selectSingleNode("/database_configuration/database_uninstallation");
        xNodeInstall.appendChild(GenerateSchemaUpgradeTables(this.ConnectStringForOperate, true));
        
        xDatabaseInstallSql.loadXML(xProfile.transformNode(xDatabaseSchemaTransform));
        WScript.Echo("after xDatabaseInstallSql.loadXML");
        var xSqlScriptsList = xDatabaseInstallSql.selectNodes("/database/database_uninstallation/sql");
        var xSql = null;
		WScript.Echo("begin execute the sql commands");
		WScript.Echo("*************************************************************");
        while (xSqlScriptsList && (xSql = xSqlScriptsList.nextNode()))
        {
            if (!visitor(xSql.text, (xSql.getAttribute("haltonerror") == null || xSql.getAttribute("haltonerror") == true)))
                break;
        }
        
        this.RollbackDLPChanges(visitor, cn);
        this.RollbackDLPKeywordChanges(visitor, cn);
        this.RollbackDLPExpressionChanges(visitor, cn);
        this.UpdateDLPPolicy(visitor, cn);
		this.UpdateScheduleReport(visitor, cn);
		WScript.Echo("*************************************************************");
		WScript.Echo("end execute the sql commands");
        WScript.Echo("Leave GetRollbackScripts");
    }
    
    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    function GenerateSchemaUpgradeTables(ConnectString, IsRollback)
    {
    	  WScript.Echo("Enter GenerateSchemaUpgradeTables");
        // ADO definition SchemaEnum
        var adSchemaTables      = 20;
        var adSchemaColumns     = 4;
        //
        var conn = new ActiveXObject("ADODB.Connection");
        WScript.Echo("conn.Open");
        conn.Open(ConnectString);
        
        var xSchemaUpgrade = XDoc();
        
        if(IsRollback)
        {
            xSchemaUpgrade.loadXML("<schema_rollback/>");
        }
        else
        {
            xSchemaUpgrade.loadXML("<schema_upgrade/>");
        }
        
		WScript.Echo("conn.OpenSchema");
        var rsSchemaTables = conn.OpenSchema(adSchemaTables);
        var rsSchemaColumns = conn.OpenSchema(adSchemaColumns);
        while (!rsSchemaTables.EOF)
        {
            var tblType = rsSchemaTables("TABLE_TYPE");
            var tblName = rsSchemaTables("TABLE_NAME");
            logUpgradeSchema.WriteFormat("%1% - %2%", rsSchemaTables("TABLE_TYPE"), rsSchemaTables("TABLE_NAME"));
            if (rsSchemaTables("TABLE_TYPE") == "TABLE")
            {
                var arrFilter = new Array(3);
                //arrFilter.push("");
                //arrFilter.push("");
                arrFilter[2] = String(tblName);
                var rsSchemaColumns = conn.OpenSchema(adSchemaColumns, arrFilter);

                var xElemTable = xSchemaUpgrade.createElement("table");
                xElemTable.setAttribute("name", tblName);
                while (!rsSchemaColumns.EOF)
                {
                    var xElemCol = xSchemaUpgrade.createElement("field");
                    xElemCol.setAttribute("name", rsSchemaColumns("COLUMN_NAME"));
                    xElemTable.appendChild(xElemCol);
                    logUpgradeSchema.WriteFormat("%1% - %2%", rsSchemaColumns("TABLE_NAME"), rsSchemaColumns("COLUMN_NAME"));
                    rsSchemaColumns.MoveNext();
                }
                xSchemaUpgrade.documentElement.appendChild(xElemTable);
            }
            rsSchemaTables.MoveNext();
        }
		//xSchemaUpgrade.save(sWorkingDirectory + "\\" +"schema.xml")
		WScript.Echo("Leave GenerateSchemaUpgradeTables");
        return xSchemaUpgrade.documentElement;
    }
  }  
    

///////////////////////////////////////////////////////////////////////////////////////////////////
function XDoc()
{
    var oXmlDoc = null;
    if (oXmlDoc == null) { try { oXmlDoc = new ActiveXObject("MSXML2.DOMDocument.6.0"); 
        oXmlDoc.setProperty("ProhibitDTD", false);    // MSXML 6 
	    oXmlDoc.setProperty("UseInlineSchema", true); // MSXML 6 
	    oXmlDoc.setProperty("AllowXsltScript", true); 
        oXmlDoc.setProperty("AllowDocumentFunction", true); } catch(e) {} }
    if (oXmlDoc == null) { try { oXmlDoc = new ActiveXObject("MSXML2.DOMDocument.4.0"); } catch(e) {} }
    if (oXmlDoc == null) { try { oXmlDoc = new ActiveXObject("MSXML2.DOMDocument.3.0"); } catch(e) {} }
    if (oXmlDoc == null) throw "unable to create a MSXML instance";
    oXmlDoc.validateOnParse = false;
    oXmlDoc.resolveExternals = true;
    return oXmlDoc;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function Log(enable)
{
    this.Write = function ()
    {
        for (i = 0; i != arguments.length; ++i)
            WriteImp(arguments[i]);
        WriteImp("\n");
    }
    this.WriteFormat = function(fmtString)
    {
        var strFormated = new String(fmtString);
        for (i = 1; i < arguments.length; ++i)
            strFormated = strFormated.replace("%" + i + "%", arguments[i]);
        WriteImp(strFormated);
        WriteImp("\n");
    }
    function WriteImp(item)
    {
        if (enable)
            WScript.Echo(item);
    }
}

