//
function trim(s)
{
	var len = s.length;
	if (len == 0)
		return s;
		
	var idxLeft = 0, idxRight = len - 1;
	
	// trim left
	var i = idxLeft;
	while (i < len)
	{
		var ch = s.charAt(i);
		if (ch != " " && ch != "\t")
			break;
		i++;
	}
	if (i < len)
		idxLeft = i;
	
	// trim right
	i = idxRight;
	while (i > idxLeft)
	{
		var ch = s.charAt(i);
		if (ch != " " && ch != "\t")
			break;
		--i;
	}
	if (i > idxLeft)
		idxRight = i;

	return s.substring(idxLeft, idxRight+1);
}

// map of digital asset id
function IDMap(oldId, newId)
{
	this.oldId = oldId;
	this.newId = newId;
}

var fso = new ActiveXObject("Scripting.FileSystemObject");
var DBProfile = WScript.Arguments.length > 0 ? WScript.Arguments(0) : "";
var operation   = WScript.Arguments.length > 1 ? WScript.Arguments(1) : "create";
var SQLServerPassword = WScript.Arguments.length > 2 ? WScript.Arguments(2) : "";

WScript.StdOut.WriteLine("");
WScript.StdOut.WriteLine("--------------------------log started------------------------------");
var currentDate = new Date();
WScript.StdOut.WriteLine(currentDate);
WScript.StdOut.WriteLine("");		
WScript.Echo("DBProfile:" + DBProfile);
WScript.Echo("operation:" + operation);

if(SQLServerPassword == "{SQLSERVERPASSWORD}")
{
	SQLServerPassword = "";
}

if (fso.FileExists(DBProfile))
{
    try
    {
          
        DBProfile = fso.GetAbsolutePathName(DBProfile);
        var sWorkingDirectory = fso.GetParentFolderName(DBProfile);
 		WScript.Echo("sWorkingDirectory:" + sWorkingDirectory);
        var dbProfile = new DatabaseProfile(DBProfile, sWorkingDirectory);
        if (operation == "create")
            dbProfile.CreateDatabase();
        else if(operation == "rollback")
            dbProfile.RollbackDatabase();
        else if (operation == "install-scripts")
            dbProfile.CreateInstallSqlStatements();
        else if (operation == "upgrade-scripts")
            dbProfile.CreateUpgradeSqlStatements();
        else if (operation == "rollback-scripts")
            dbProfile.CreateRollbackSqlStatements();
        else if (operation == "switch-dbfile")
       	    dbProfile.SwitchDBFile();
		else if (operation == "test-connection")
			dbProfile.TestConnection();
   	    try{
   	        fso.CreateTextFile(dbProfile.HomeDir+"\\InstallDBFinish.lck");
   	    }catch(e)
   	    {
   	    	WScript.StdErr.WriteLine("fso.CreateTextFile fail");
   	        WScript.StdErr.WriteLine( e.message + " (" +  e.number + ") ");       	        
   	    }       	
    }
    catch(e)
    {
    	WScript.StdErr.WriteLine("catch exception in the outest catch");
        WScript.StdErr.WriteLine(e.message + " (" +  e.number + ") ");
        WScript.Quit(e.number);
    }
}
else
{
    WScript.StdErr.WriteLine("A valid database profile is needed. Your input is \"" + DBProfile + "\"");
    WScript.StdErr.WriteLine("Usage: CScript //E:JavaScript dbDatabaseCreation.js DATABASE-PROFILE-NAME [create(default)|install-scripts|upgrade-scripts]");
    WScript.Quit(1);
}


function DatabaseProfile(filename, sWorkingDirectory)
{
    var log = new Log(true);
    var logUpgradeSchema = new Log(false);
    var fso = new ActiveXObject("Scripting.FileSystemObject");
    var xProfile = XDoc();
    xProfile.load(filename);
    
  

    this.WorkingDirectory = sWorkingDirectory;

    this.Type = xProfile.selectSingleNode("/database_configuration/database_type").text;
    this.Host = xProfile.selectSingleNode("/database_configuration/database_host").text;
    this.Name = xProfile.selectSingleNode("/database_configuration/database_name").text;
    this.File = xProfile.selectSingleNode("/database_configuration/database_file").text;
    this.HomeDir = xProfile.selectSingleNode("/database_configuration/product_home_dir").text;
    WScript.Echo("database_type:" + this.Type);
    WScript.Echo("database_host:" + this.Host);
    WScript.Echo("database_name:" + this.Name);
    WScript.Echo("database_file:" + this.File);
    WScript.Echo("product_home_dir:" + this.HomeDir);
    this.IsInstalled = true;   // FOR SMEX 10 SP1 installation only
   

    this.ConnectStringForInstall = xProfile.selectSingleNode("/database_configuration/database_initialization/connect_string[@for='install']").text;
    this.ConnectStringForOperate = xProfile.selectSingleNode("/database_configuration/database_initialization/connect_string[@for='operate']").text;
	WScript.Echo("ConnectStringForInstall:" + this.ConnectStringForInstall);
	WScript.Echo("ConnectStringForOperate:" + this.ConnectStringForOperate);
    if(this.Type != "JET")
	{
	    this.ConnectStringForOperate += SQLServerPassword;
	    this.IsSeperateSQLServer = xProfile.selectSingleNode("/database_configuration/database_is_seperate_sql_server").text;
	    this.SecurityString = xProfile.selectSingleNode("/database_configuration/database_security_string").text;
	    this.UserId = xProfile.selectSingleNode("/database_configuration/database_userid").text;
	}	    
    

   
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.CreateDatabase = function ()
    {
    	WScript.Echo("Enter CreateDatabase");	
        var conn = new ActiveXObject("ADODB.Connection");
        

        if (this.Type == "JET")
        {
            var jetEngine = new ActiveXObject("JRO.JetEngine");
            jetEngine.CompactDatabase("Data Source = " + this.File, "Data Source = " + this.File + ".bak");
          
            var file = new ActiveXObject("Scripting.FileSystemObject");
            file.DeleteFile(this.File);
            file.MoveFile(this.File + ".bak", this.File);
        }
        
        var ConnectString = this.ConnectStringForOperate;
        WScript.Echo("conn.Open");
       	conn.Open(ConnectString);
		
		//add transaction
	    WScript.Echo("conn.BeginTrans");	
		conn.BeginTrans();
		
        function SqlScriptIterator(sqlInstallScript, bHaltOnError)
        {
            try
            {
            	sqlInstallScript=sqlInstallScript.replace(/\n/g,"\r\n");
            	log.Write(sqlInstallScript);
                conn.Execute(sqlInstallScript);
            }
            catch(e)
            {
                if (bHaltOnError)
                {
                    throw e;
                }
                else
                {
                	WScript.Echo("catch exception in CreateDatabase:SqlScriptIterator");
					log.Write(sqlInstallScript);
                	log.Write("Expected error: ", e.message, " (", e.number, ") ");
                }

            }
            return true;
        }
		
	    try
		{
			WScript.StdOut.WriteLine("begin upgrade tables");
			this.GetUpgradeScripts(SqlScriptIterator, conn);
		}
		catch(e)
		{
			WScript.Echo("catch exception in CreateDatabase, RollbackTrans now");	
			conn.RollbackTrans();
			conn.Close();
			throw e;
		}
		WScript.Echo("conn.CommitTrans");
		conn.CommitTrans();
		conn.Close();
		WScript.Echo("Leave CreateDatabase");
    }
    
	///////////////////////////////////////////////////////////////////////////////////////////////
	this.TestConnection = function()
	{
		WScript.Echo("Enter TestConnection");
		try
		{
			var conn = new ActiveXObject("ADODB.Connection");
			var ConnectString = this.ConnectStringForOperate;
			WScript.Echo("conn.Open");
			conn.Open(ConnectString);
			conn.Close();
		}
		catch(e)
		{
			WScript.Echo("catch exception in TestConnection");
			throw e;
		}
		WScript.Echo("Leave TestConnection");
	}
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.RollbackDatabase = function()
    {
		WScript.Echo("Enter RollbackDatabase");
		var conn = new ActiveXObject("ADODB.Connection");
		
        if (this.Type == "JET")
        {
            var jetEngine = new ActiveXObject("JRO.JetEngine");
            jetEngine.CompactDatabase("Data Source = " + this.File, "Data Source = " + this.File + ".bak");
          
            var file = new ActiveXObject("Scripting.FileSystemObject");
            file.DeleteFile(this.File);
            file.MoveFile(this.File + ".bak", this.File);
        }
        
        var ConnectString = this.ConnectStringForOperate;
        WScript.Echo("conn.Open");
       	conn.Open(ConnectString);
		
		//add transaction
		WScript.Echo("conn.BeginTrans");
		conn.BeginTrans();
		
        function SqlScriptIterator(sqlInstallScript, bHaltOnError)
        {
            try
            {
            	sqlInstallScript=sqlInstallScript.replace(/\n/g,"\r\n");
                conn.Execute(sqlInstallScript);
                log.Write(sqlInstallScript);
            }
            catch(e)
            {
                if (bHaltOnError)
                {
                    throw e;
                }
                else
                {
                    WScript.Echo("catch exception in RollbackDatabase:SqlScriptIterator");
					log.Write(sqlInstallScript);
                    log.Write("Expected error: ", e.message, " (", e.number, ") ");
                }

            }
            return true;
        }
		
        try
		{
			WScript.StdOut.WriteLine("begin rollback tables");
			this.GetRollbackScripts(SqlScriptIterator, conn);
		}
		catch(e)
		{
			WScript.Echo("catch exception in RollbackDatabase, RollbackTrans now");	
			conn.RollbackTrans();
			conn.Close();
			throw e;
		}
		WScript.Echo("conn.CommitTrans");
		conn.CommitTrans();
		conn.Close();
		WScript.Echo("Leave RollbackDatabase");
    };
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.CreateInstallSqlStatements = function ()
    {
    	WScript.Echo("Enter CreateInstallSqlStatements");
        function SqlScriptIterator(sqlInstallScript, bHaltOnError)
        {
            log.Write(sqlInstallScript);
            log.Write("GO");
            log.Write("");
            return true;
        }
        this.GetInstallScripts(SqlScriptIterator);
        WScript.Echo("Leave CreateInstallSqlStatements");
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.CreateUpgradeSqlStatements = function ()
    {
    	WScript.Echo("Enter CreateUpgradeSqlStatements");
        function SqlScriptIterator(sqlInstallScript, bHaltOnError)
        {
            log.Write(sqlInstallScript);
            log.Write("GO");
            log.Write("");
            return true;
        }
        this.GetUpgradeScripts(SqlScriptIterator);
        WScript.Echo("Leave CreateUpgradeSqlStatements");
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.CreateRollbackSqlStatements = function ()
    {
    	WScript.Echo("Enter CreateRollbackSqlStatements");
        function SqlScriptIterator(sqlInstallScript, bHaltOnError)
        {
            log.Write(sqlInstallScript);
            log.Write("GO");
            log.Write("");
            return true;
        }
        this.GetRollbackScripts(SqlScriptIterator, null);
        WScript.Echo("Leave CreateRollbackSqlStatements");
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.SwitchDBFile = function()
    {
    	WScript.Echo("Enter SwitchDBFile");
    	if(this.Type == "SQLSVR" && WScript.Arguments.length>2)
    	{
    		var sNewFile = WScript.Arguments(2);
    		var conn = new ActiveXObject("ADODB.Connection");

            conn.Open("Provider=SQLOLEDB.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=master;Data Source=" + this.Host);
            conn.Execute("USE master");
            try
            {
                conn.Execute("DROP DATABASE [" + this.Name + "]");
            }
            catch(e)
            {
            	                
            }
            
            conn.Execute("CREATE DATABASE [" + this.Name + "] ON ( FILENAME = " + sNewFile + ".mdf' ), ( FILENAME = " + sNewFile + ".ldf ) FOR ATTACH");      
            conn.Execute("ALTER  DATABASE [" + this.Name + "] SET AUTO_SHRINK ON");
	        
            conn.Close();               		
    	}
    	WScript.Echo("Leave SwitchDBFile");
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.GetInstallScripts = function (visitor)
    {
    	WScript.Echo("Enter GetInstallScripts");
        var fSqlSatementCreation     = sWorkingDirectory + "\\" + "dbTableCreationSql4SP1.xslt";
        var xDatabaseInstallSql      = XDoc();
        var xDatabaseSchemaTransform = XDoc();
        xDatabaseSchemaTransform.load(fSqlSatementCreation);
         WScript.Echo("after xDatabaseSchemaTransform.load");
        xDatabaseInstallSql.loadXML(xProfile.transformNode(xDatabaseSchemaTransform));
        var xSqlScriptsList = xDatabaseInstallSql.selectNodes("/database/database_installation/sql");
        var xSql = null;
        while (xSqlScriptsList && (xSql = xSqlScriptsList.nextNode()))
        {
            if (!visitor(xSql.text))
                break;
        }
        
        WScript.Echo("Leave GetInstallScripts");
    }

	///////////////////////////////////////////////////////////////////////////////////////////////
    this.GetUpgradeScripts = function (visitor, cn)
    {
    	WScript.Echo("Enter GetUpgradeScripts");
        var fSqlSatementCreation     = sWorkingDirectory + "\\" + "dbTableCreationSql4SP1.xslt";
        var xDatabaseInstallSql      = XDoc();
        var xDatabaseSchemaTransform = XDoc();
        xDatabaseSchemaTransform.load(fSqlSatementCreation);
        WScript.Echo("after xDatabaseSchemaTransform.load");
        var xNodeInstall = xProfile.selectSingleNode("/database_configuration/database_installation");
        xNodeInstall.appendChild(GenerateSchemaUpgradeTables(this.ConnectStringForOperate, false));
		
		//xProfile.save(sWorkingDirectory + "\\" + "profile.xml");
        
        xDatabaseInstallSql.loadXML(xProfile.transformNode(xDatabaseSchemaTransform));
		//xProfile.save(sWorkingDirectory + "\\" + "profile.xml");
        
        xDatabaseInstallSql.loadXML(xProfile.transformNode(xDatabaseSchemaTransform));
		WScript.Echo("after xDatabaseInstallSql.loadXML");
        //xDatabaseInstallSql.save(sWorkingDirectory + "\\sql.xml");
		
        var xSqlScriptsList = xDatabaseInstallSql.selectNodes("/database/database_installation/sql");
		
		//log.Write(xSqlScriptsList.length);
		WScript.Echo("begin execute the sql commands");
		WScript.Echo("*************************************************************");
        var xSql = null;
        while (xSqlScriptsList && (xSql = xSqlScriptsList.nextNode()))
        {
            if (!visitor(xSql.text, (xSql.getAttribute("haltonerror") == null || xSql.getAttribute("haltonerror") == true)))
                break;
        }
        
       
		WScript.Echo("*************************************************************");
		WScript.Echo("end execute the sql commands");
				WScript.Echo("Leave GetUpgradeScripts");
        
    }
     ///////////////////////////////////////////////////////////////////////////////////////////////
    this.GetRollbackScripts = function (visitor, cn)
    {
    	WScript.Echo("Enter GetRollbackScripts");
        var fSqlSatementCreation     = sWorkingDirectory + "\\" + "dbTableCreationSql4SP1.xslt";
        var xDatabaseInstallSql      = XDoc();
        var xDatabaseSchemaTransform = XDoc();
        xDatabaseSchemaTransform.load(fSqlSatementCreation);
        WScript.Echo("after xDatabaseSchemaTransform.load");
        var xNodeInstall = xProfile.selectSingleNode("/database_configuration/database_uninstallation");
        xNodeInstall.appendChild(GenerateSchemaUpgradeTables(this.ConnectStringForOperate, true));
        
        xDatabaseInstallSql.loadXML(xProfile.transformNode(xDatabaseSchemaTransform));
        WScript.Echo("after xDatabaseInstallSql.loadXML");
        var xSqlScriptsList = xDatabaseInstallSql.selectNodes("/database/database_uninstallation/sql");
        var xSql = null;
		WScript.Echo("begin execute the sql commands");
		WScript.Echo("*************************************************************");
        while (xSqlScriptsList && (xSql = xSqlScriptsList.nextNode()))
        {
            if (!visitor(xSql.text, (xSql.getAttribute("haltonerror") == null || xSql.getAttribute("haltonerror") == true)))
                break;
        }
        
		WScript.Echo("*************************************************************");
		WScript.Echo("end execute the sql commands");
        WScript.Echo("Leave GetRollbackScripts");
    }
    
    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    function GenerateSchemaUpgradeTables(ConnectString, IsRollback)
    {
    	  WScript.Echo("Enter GenerateSchemaUpgradeTables");
        // ADO definition SchemaEnum
        var adSchemaTables      = 20;
        var adSchemaColumns     = 4;
        //
        var conn = new ActiveXObject("ADODB.Connection");
        WScript.Echo("conn.Open");
        conn.Open(ConnectString);
        
        var xSchemaUpgrade = XDoc();
        
        if(IsRollback)
        {
            xSchemaUpgrade.loadXML("<schema_rollback/>");
        }
        else
        {
            xSchemaUpgrade.loadXML("<schema_upgrade/>");
        }
        
		WScript.Echo("conn.OpenSchema");
        var rsSchemaTables = conn.OpenSchema(adSchemaTables);
        var rsSchemaColumns = conn.OpenSchema(adSchemaColumns);
        while (!rsSchemaTables.EOF)
        {
            var tblType = rsSchemaTables("TABLE_TYPE");
            var tblName = rsSchemaTables("TABLE_NAME");
            logUpgradeSchema.WriteFormat("%1% - %2%", rsSchemaTables("TABLE_TYPE"), rsSchemaTables("TABLE_NAME"));
            if (rsSchemaTables("TABLE_TYPE") == "TABLE")
            {
                var arrFilter = new Array(3);
                //arrFilter.push("");
                //arrFilter.push("");
                arrFilter[2] = String(tblName);
                var rsSchemaColumns = conn.OpenSchema(adSchemaColumns, arrFilter);

                var xElemTable = xSchemaUpgrade.createElement("table");
                xElemTable.setAttribute("name", tblName);
                while (!rsSchemaColumns.EOF)
                {
                    var xElemCol = xSchemaUpgrade.createElement("field");
                    xElemCol.setAttribute("name", rsSchemaColumns("COLUMN_NAME"));
                    xElemTable.appendChild(xElemCol);
                    logUpgradeSchema.WriteFormat("%1% - %2%", rsSchemaColumns("TABLE_NAME"), rsSchemaColumns("COLUMN_NAME"));
                    rsSchemaColumns.MoveNext();
                }
                xSchemaUpgrade.documentElement.appendChild(xElemTable);
            }
            rsSchemaTables.MoveNext();
        }
		//xSchemaUpgrade.save(sWorkingDirectory + "\\" +"schema.xml")
		WScript.Echo("Leave GenerateSchemaUpgradeTables");
        return xSchemaUpgrade.documentElement;
    }
  }  
    

///////////////////////////////////////////////////////////////////////////////////////////////////
function XDoc()
{
    var oXmlDoc = null;
    if (oXmlDoc == null) { try { oXmlDoc = new ActiveXObject("MSXML2.DOMDocument.6.0"); 
        oXmlDoc.setProperty("ProhibitDTD", false);    // MSXML 6 
	    oXmlDoc.setProperty("UseInlineSchema", true); // MSXML 6 
	    oXmlDoc.setProperty("AllowXsltScript", true); 
        oXmlDoc.setProperty("AllowDocumentFunction", true); } catch(e) {} }
    if (oXmlDoc == null) { try { oXmlDoc = new ActiveXObject("MSXML2.DOMDocument.4.0"); } catch(e) {} }
    if (oXmlDoc == null) { try { oXmlDoc = new ActiveXObject("MSXML2.DOMDocument.3.0"); } catch(e) {} }
    if (oXmlDoc == null) throw "unable to create a MSXML instance";
    oXmlDoc.validateOnParse = false;
    oXmlDoc.resolveExternals = true;
    return oXmlDoc;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function Log(enable)
{
    this.Write = function ()
    {
        for (i = 0; i != arguments.length; ++i)
            WriteImp(arguments[i]);
        WriteImp("\n");
    }
    this.WriteFormat = function(fmtString)
    {
        var strFormated = new String(fmtString);
        for (i = 1; i < arguments.length; ++i)
            strFormated = strFormated.replace("%" + i + "%", arguments[i]);
        WriteImp(strFormated);
        WriteImp("\n");
    }
    function WriteImp(item)
    {
        if (enable)
            WScript.Echo(item);
    }
}

