var ServerName;
var sWorkDir;

var fso = new ActiveXObject("Scripting.FileSystemObject");
var DBProfile = WScript.Arguments.length > 0 ? WScript.Arguments(0) : "";
var operation   = WScript.Arguments.length > 1 ? WScript.Arguments(1) : "install";
var dbFunction	= WScript.Arguments.length > 2 ? WScript.Arguments(2) : "GetQuarantinePath";
var SQLServerPassword = WScript.Arguments.length > 3 ? WScript.Arguments(3) : "";

WScript.StdOut.WriteLine("");
WScript.StdOut.WriteLine("--------------------------log started------------------------------");
var currentDate = new Date();
WScript.StdOut.WriteLine(currentDate);
WScript.StdOut.WriteLine("");		
WScript.Echo("DBProfile:" + DBProfile);
WScript.Echo("operation:" + operation);
WScript.Echo("dbFunction:"  + dbFunction);

if(SQLServerPassword == "{SQLSERVERPASSWORD}")
{
	SQLServerPassword = "";
}

if (fso.FileExists(DBProfile))
{
    try
    { 
        DBProfile = fso.GetAbsolutePathName(DBProfile);
        var sWorkingDirectory = fso.GetParentFolderName(DBProfile);
 		WScript.Echo("sWorkingDirectory:" + sWorkingDirectory);
        var dbProfile = new DatabaseProfile(DBProfile, sWorkingDirectory);
        if (operation == "install")
		{
			if(dbFunction == "GetQuarantinePath")  //add new requirement here when get other value from database
				dbProfile.GetInstallQuarantinePath();
		}
		
		else if (operation == "uninstall")
		{
			if(dbFunction == "GetQuarantinePath")
				dbProfile.GetUninstallQuarantinePath();
		}
        
		else if (operation == "test-connection")
			dbProfile.TestConnection();
		
   	    try{
   	        fso.CreateTextFile(dbProfile.HomeDir+"\\GetValueFromDBFinish.lck");
   	    }catch(e)
   	    {
   	    	WScript.StdErr.WriteLine("fso.CreateTextFile fail");
   	        WScript.StdErr.WriteLine( e.message + " (" +  e.number + ") ");       	        
   	    }       	
    }
    catch(e)
    {
    	WScript.StdErr.WriteLine("catch exception in the outest catch");
        WScript.StdErr.WriteLine(e.message + " (" +  e.number + ") ");
        WScript.Quit(e.number);
    }
}
else
{
    WScript.StdErr.WriteLine("A valid database profile is needed. Your input is \"" + DBProfile + "\"");
    WScript.StdErr.WriteLine("Usage: CScript //E:JavaScript dbDatabaseCreation.js DATABASE-PROFILE-NAME [GetQuarantinePath(default)");
    WScript.Quit(1);
}

function DatabaseProfile(filename, sWorkingDirectory)
{
    var log = new Log(true);
    var logUpgradeSchema = new Log(false);
    var fso = new ActiveXObject("Scripting.FileSystemObject");
    var xProfile = XDoc();
	
    xProfile.load(filename);
	if (xProfile.parseError.errorCode != 0) 
	{
		var Err = xProfile.parseError;
		WScript.Echo("Parse xml error: " + Err.reason);
	} 
	
    this.WorkingDirectory = sWorkingDirectory;
	sWorkDir=sWorkingDirectory;

    this.Name = xProfile.selectSingleNode("/database_configuration/database_name").text;
	this.Type = xProfile.selectSingleNode("/database_configuration/database_type").text;
	this.File = xProfile.selectSingleNode("/database_configuration/database_file").text;
	this.HomeDir = xProfile.selectSingleNode("/database_configuration/product_home_dir").text;
	ServerName = xProfile.selectSingleNode("/database_configuration/server_name").text;
	
	this.XmlType = xProfile.selectSingleNode("/database_configuration/database_xml_type").text;
	
	WScript.Echo("database_type:" + this.Type);
    WScript.Echo("database_name:" + this.Name);
	WScript.Echo("database_file:" + this.File);
	WScript.Echo("product_home_dir:" + this.HomeDir);
	WScript.Echo("ServerName:" + ServerName);

    this.ConnectStringForOperate = xProfile.selectSingleNode("/database_configuration/database_initialization/connect_string[@for='operate']").text;
	WScript.Echo("ConnectStringForOperate:" + this.ConnectStringForOperate);
	
    if(this.Type != "JET")
	{
	    this.ConnectStringForOperate += SQLServerPassword;
	    this.IsSeperateSQLServer = xProfile.selectSingleNode("/database_configuration/database_is_seperate_sql_server").text;
	    this.SecurityString = xProfile.selectSingleNode("/database_configuration/database_security_string").text;
	    this.UserId = xProfile.selectSingleNode("/database_configuration/database_userid").text;
	}	    
    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.GetInstallQuarantinePath = function ()
    {
    	WScript.Echo("Enter GetInstallQuarantinePath");	
        var conn = new ActiveXObject("ADODB.Connection");
        
        if (this.Type == "JET")
        {
            var jetEngine = new ActiveXObject("JRO.JetEngine");
            jetEngine.CompactDatabase("Data Source = " + this.File, "Data Source = " + this.File + ".bak");
          
            var file = new ActiveXObject("Scripting.FileSystemObject");
            file.DeleteFile(this.File);
            file.MoveFile(this.File + ".bak", this.File);
        }
        
        var ConnectString = this.ConnectStringForOperate;
        WScript.Echo("conn.Open");
       	conn.Open(ConnectString);
		
		//get APT quarantine path from db, and save it in dbcfg_QuarantinePathForInstall.txt,this file will be used in toolHandleIncomplementMails.exe
		var filePath = this.HomeDir + "\\config\\dbcfg_QuarantinePathForInstall.txt";
		try
		{
			//during installation, there will not suspicious url folder, so just get quarantine path for file only
				
			var column="VS_APT_QUARANTINE_DIRECTORY";
			var table="TM_VirusScan";
			var selectcondition = "CFG_INDEX ='SMEX_PLC_NULL:SMEX_SUB_CFG_VS_RS'";
			GetColumnValueAndSaveToFile(conn,column,table,filePath,selectcondition);
		}
		catch(e)
		{
			WScript.StdErr.WriteLine("catch exception in CreateDatabase when GetColumnValueAndSaveToFile during installation!");
			WScript.StdErr.WriteLine( e.message + " (" +  e.number + ") ");
			conn.Close();
			return;
		}
		conn.Close();
		WScript.Echo("Leave GetInstallQuarantinePath");
		
			
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	this.TestConnection = function()
	{
		WScript.Echo("Enter TestConnection");
		try
		{
			var conn = new ActiveXObject("ADODB.Connection");
			var ConnectString = this.ConnectStringForOperate;
			WScript.Echo("conn.Open");
			conn.Open(ConnectString);
			conn.Close();
		}
		catch(e)
		{
			WScript.Echo("catch exception in TestConnection");
			throw e;
		}
		WScript.Echo("Leave TestConnection");
	}
    ///////////////////////////////////////////////////////////////////////////////////////////////
		
	this.GetUninstallQuarantinePath = function ()
	{
		WScript.Echo("Enter GetUninstallQuarantinePath");	
        var conn = new ActiveXObject("ADODB.Connection");
		
		if (this.Type == "JET")
        {
            var jetEngine = new ActiveXObject("JRO.JetEngine");
            jetEngine.CompactDatabase("Data Source = " + this.File, "Data Source = " + this.File + ".bak");
          
            var file = new ActiveXObject("Scripting.FileSystemObject");
            file.DeleteFile(this.File);
            file.MoveFile(this.File + ".bak", this.File);
        }
        
        var ConnectString = this.ConnectStringForOperate;
        WScript.Echo("conn.Open");
       	conn.Open(ConnectString);
		
		try
		{
			// for suspicious file	
			var column = "VS_APT_QUARANTINE_DIRECTORY";
			var table = "TM_VirusScan";
			var selectcondition = "CFG_INDEX='SMEX_PLC_NULL:SMEX_SUB_CFG_VS_RS'";
			var filePath = this.HomeDir + "\\config\\dbcfg_QuarantinePathForUninstallFile.txt";
			GetColumnValueAndSaveToFile(conn,column,table,filePath,selectcondition);
					
			// for suspicious url	
			column = "WTP_APT_QUARANTINE_PATH";
			table = "TM_WebThreatProtection";
			selectcondition = "CFG_INDEX='SMEX_PLC_NULL:SMEX_SUB_CFG_WTP_RS'";
			filePath = this.HomeDir + "\\config\\dbcfg_QuarantinePathForUninstallUrl.txt";
			GetColumnValueAndSaveToFile(conn,column,table,filePath,selectcondition);
		}
		catch(e)
		{
			WScript.StdErr.WriteLine("catch exception in GetColumnValueAndSaveToFile during uninstallation!");
			WScript.StdErr.WriteLine( e.message + " (" +  e.number + ") ");
			conn.Close();
			return;
		}
		
		conn.Close();
		WScript.Echo("Leave GetUninstallQuarantinePath");
		
	}

}
		
///////////////////////////////////////////////////////////////////////////////////////////////////
function ExecuteSelectWithWhere(conn,columnname,tablename,selectcondition)
{
	var rsForFile = conn.Execute("SELECT "+ columnname + " FROM "+tablename+"_"+ServerName+" WHERE " + selectcondition);
	return rsForFile;
}

function ExecuteSelectWithoutWhere(conn,columnname,tablename)
{
	var dbRecord = conn.Execute("SELECT "+ columnname + " FROM "+tablename+"_"+ServerName);
	return dbRecord;
}

function GetColumnValueAndSaveToFile(conn,columnname,tablename,filepath,selectcondition)
{
	var dbRecord;
	
	//get column value from db
	if(selectcondition!=null)
		dbRecord=ExecuteSelectWithWhere(conn,columnname,tablename,selectcondition);
	else
		dbRecord=ExecuteSelectWithoutWhere(conn,columnname,tablename)
	
	WScript.Echo(dbRecord(0).Value);
	
	//save to file
	var fs = new ActiveXObject("Scripting.FileSystemObject"); 
	var f = fs.OpenTextFile(filepath,2,true,-1);
	f.Write(dbRecord(0).Value);
	f.Close();
		
	dbRecord.Close();
}

function XDoc()
{
    var oXmlDoc = null;
    if (oXmlDoc == null) { try { oXmlDoc = new ActiveXObject("MSXML2.DOMDocument.6.0"); 
        oXmlDoc.setProperty("ProhibitDTD", false);    // MSXML 6 
	    oXmlDoc.setProperty("UseInlineSchema", true); // MSXML 6 
	    oXmlDoc.setProperty("AllowXsltScript", true); 
        oXmlDoc.setProperty("AllowDocumentFunction", true); } catch(e) {} }
    if (oXmlDoc == null) { try { oXmlDoc = new ActiveXObject("MSXML2.DOMDocument.4.0"); } catch(e) {} }
    if (oXmlDoc == null) { try { oXmlDoc = new ActiveXObject("MSXML2.DOMDocument.3.0"); } catch(e) {} }
    if (oXmlDoc == null) throw "unable to create a MSXML instance";
    oXmlDoc.validateOnParse = false;
    oXmlDoc.resolveExternals = true;
    return oXmlDoc;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function Log(enable)
{
    this.Write = function ()
    {
        for (i = 0; i != arguments.length; ++i)
            WriteImp(arguments[i]);
        WriteImp("\n");
    }
    this.WriteFormat = function(fmtString)
    {
        var strFormated = new String(fmtString);
        for (i = 1; i < arguments.length; ++i)
            strFormated = strFormated.replace("%" + i + "%", arguments[i]);
        WriteImp(strFormated);
        WriteImp("\n");
    }
    function WriteImp(item)
    {
        if (enable)
            WScript.Echo(item);
    }
}

