﻿<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:import href="report_common.xslt"/>
	<xsl:output method="html" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>

	<xsl:template match="/">

		<!--||Virus/Malware Graph||-->
		<tr><td class="tableheadergreyM">Viruses/Malware Graph</td></tr>
		<tr><td align="center">
			<img alt="Virus/Malware graph"><xsl:attribute name="src">images/<xsl:value-of select="/report/dataset/data[starts-with(@name,'report_item_virus_graph')]/@name"/>.png</xsl:attribute></img></td></tr>
		<tr><td class="border2"><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td></tr>

		<!--||Spyware/Grayware Graph||-->
		<tr><td class="tableheadergreyM">Spyware/Grayware Graph</td></tr>
		<tr><td align="center">
			<img alt="Spyware/Grayware graph"><xsl:attribute name="src">images/<xsl:value-of select="/report/dataset/data[starts-with(@name,'report_item_spyware_graph')]/@name"/>.png</xsl:attribute></img></td></tr>
		<tr><td class="border2"><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td></tr>
		
		<!-- allen_chen 2012-08-24, ATSE engine integration -->
		<tr><td class="tableheadergreyM">Advanced Threats Graph</td></tr>
		<tr><td align="center">
			<img alt="Advanced Threats Graph"><xsl:attribute name="src">images/<xsl:value-of select="/report/dataset/data[starts-with(@name,'report_item_exploits_graph')]/@name"/>.png</xsl:attribute></img></td></tr>
		<tr><td class="border2"><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td></tr>
		
		<!--||Top Virus/Malware||-->
		<xsl:variable name="virus_top_data" select="/report//dataset/data[@name='report_item_virus_top_viruses']"/>
		<tr><td class="tableheader">Top Viruses/Malware</td></tr>
		<tr><td><table width="100%" border="0" cellpadding="0" cellspacing="0">
				<tr><td class="grey" height="20"  width="30%">Virus/Malware Name</td>
					<td class="grey-end" align="right" >Total</td></tr>
			<xsl:for-each select="$virus_top_data//datarow">
				<tr><td height="20"><xsl:attribute name="class">data<xsl:value-of select="((position()+1) mod 2) + 1"/>b</xsl:attribute><xsl:value-of select="@virus_name"/></td>
				    <td align="right"><xsl:attribute name="class">data<xsl:value-of select="((position()+1) mod 2) + 1"/></xsl:attribute><xsl:value-of select="@virus_count"/></td></tr>
			</xsl:for-each>
				</table></td></tr>
		
		<!--||Top Spyware/Grayware||-->
		<xsl:variable name="spyware_top_data" select="/report//dataset/data[@name='report_item_spyware_top_spywares']"/>
		<tr><td class="tableheader">Top Spyware/Grayware</td></tr>
		<tr><td><table width="100%" border="0" cellpadding="0" cellspacing="0">
				<tr><td class="grey" height="20" width="30%">Spyware/Grayware Name</td>
					<td class="grey-end" align="right" >Total</td></tr>
			<xsl:for-each select="$spyware_top_data//datarow">
			        <tr><td height="20"><xsl:attribute name="class">data<xsl:value-of select="((position()+1) mod 2) + 1"/>b</xsl:attribute><xsl:value-of select="@spyware_name"/></td>
				    <td align="right"><xsl:attribute name="class">data<xsl:value-of select="((position()+1) mod 2) + 1"/></xsl:attribute><xsl:value-of select="@spyware_count"/></td></tr>
			</xsl:for-each>
				</table></td></tr>
				
		<!-- allen_chen 2012-08-24, ATSE engine integration -->
		<xsl:variable name="exploits_top_data" select="/report//dataset/data[@name='report_item_exploits_top_exploits']"/>
		<tr><td class="tableheader">Top Advanced Threats</td></tr>
		<tr><td><table width="100%" border="0" cellpadding="0" cellspacing="0">
				<tr><td class="grey" height="20" width="30%">Advanced Threat Name</td>
					<td class="grey-end" align="right" >Total</td></tr>
			<xsl:for-each select="$exploits_top_data//datarow">
			        <tr><td height="20"><xsl:attribute name="class">data<xsl:value-of select="((position()+1) mod 2) + 1"/>b</xsl:attribute><xsl:value-of select="@apt_name"/></td>
				    <td align="right"><xsl:attribute name="class">data<xsl:value-of select="((position()+1) mod 2) + 1"/></xsl:attribute><xsl:value-of select="@apt_count"/></td></tr>
			</xsl:for-each>
				</table></td></tr>
				
	</xsl:template>
</xsl:stylesheet>
